/*	pcsave.cpp	-- ljsdcdev
	Non-Dreamcast saving routines
	ljsdcdev
	(c) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef _arch_dreamcast
#error This file is not for use on Dreamcast
#endif

#include "../../ljsdcdev.h"

void save_data(save_data_t * save, SDL_Surface * screen)	{
	Uint8 * data;
	gzFile fd;

	/* Get the data into an array of uint8's */
	data = (Uint8 *) malloc(sizeof(save_data_t));
	memcpy(data, save, sizeof(save_data_t));

	/* Now write it */
	fd = gzopen("save/ljsdcdev.sav", "wb9");
	gzwrite(fd, save, sizeof(save_data_t));

	/* Cleanup */
	gzclose(fd);
	free(data);
}

void read_data(save_data_t * save, SDL_Surface * screen)	{
	Uint8 * data;
	gzFile fd;

	/* Allocate the buffer */
	data = (Uint8 *) malloc(sizeof(save_data_t));

	/* Read it */
	fd = gzopen("save/ljsdcdev.sav", "rb");
	gzread(fd, data, sizeof(save_data_t));

	/* Put it in a convenient form */
	memcpy(save, data, sizeof(save_data_t));

	/* Clean up */
	gzclose(fd);
	free(data);
}
