/*	areas.h -- ljsdcdev
	Area definitions
	ljsdcdev
	(c) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "data.h"
#include "SDL_image.h"

typedef struct	{
	stat_data_t * enemy[10];
} area_data_t;

area_data_t area;

typedef struct	{
	stat_data_t smily;
	stat_data_t frowny;
	stat_data_t angry;
} enems;

enems enem;

void area_load_enem(int areanum)	{
	if(areanum == 0)	{
		/* Smily */
		enem.smily.stats.hp = 10;
		enem.smily.stats.hp_rem = 10;
		enem.smily.stats.mp = 0;
		enem.smily.stats.mp_rem = 0;
		enem.smily.stats.attack = 6;
		enem.smily.stats.defense = 5;
		enem.smily.stats.speed = 9;
		enem.smily.images.splayer = IMG_Load(SMILY);
		strcpy(enem.smily.name, "Smily");
		enem.smily.ally = -1;
		enem.smily.stats.exp = 10;

		/* Frowny */
		enem.frowny.stats.hp = 10;
		enem.frowny.stats.hp_rem = 10;
		enem.frowny.stats.mp = 0;
		enem.frowny.stats.mp_rem = 0;
		enem.frowny.stats.attack = 5;
		enem.frowny.stats.defense = 6;
		enem.frowny.stats.speed = 8;
		enem.frowny.images.splayer = IMG_Load(FROWNY);
		strcpy(enem.frowny.name, "Frowny");
		enem.frowny.ally = -1;
		enem.frowny.stats.exp = 12;

		/* Angry */
		enem.angry.stats.hp = 10;
		enem.angry.stats.hp_rem = 10;
		enem.angry.stats.mp = 0;
		enem.angry.stats.mp_rem = 0;
		enem.angry.stats.attack = 7;
		enem.angry.stats.defense = 4;
		enem.angry.stats.speed = 11;
		enem.angry.images.splayer = IMG_Load(ANGRY);
		strcpy(enem.angry.name, "Angry");
		enem.angry.ally = -1;
		enem.angry.stats.exp = 15;

		area.enemy[0] = &enem.smily;
		area.enemy[1] = &enem.smily;
		area.enemy[2] = &enem.smily;
		area.enemy[3] = &enem.smily;
		area.enemy[4] = &enem.frowny;
		area.enemy[5] = &enem.frowny;
		area.enemy[6] = &enem.frowny;
		area.enemy[7] = &enem.angry;
		area.enemy[8] = &enem.angry;
		area.enemy[9] = &enem.angry;
	}

}
