/*	battle2.cpp -- ljsdcdev
	FF1-like battle system
	ljsdcdev
	(c)2002, 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

enum {
	ACTION_NONE,
	ACTION_ATTACK,
	ACTION_MAGIC,
	ACTION_SKILL,
	ACTION_ITEM,
	ACTION_DEFEND,
	ACTION_RUN
};

static SDL_Surface * bgimage;
static SDL_Surface * buffer;
static int sel = 0;
static int sel1 = 0;
static int col = 32;
static int bat_done = 0;
static int action = ACTION_NONE;
static int exper = 0;
static stat_data_t * p[13];
static int en_menu[9] = {-1, -1, -1, -1, -1, -1, -1, -1, -1};

static void bat_message(SDL_Surface * screen, int posx, int posy, int sizex, char * message)	{
	sge_TTF_SetFontSize(font, 16);
	sge_Line(buffer, posx-16, posy, posx, posy-16, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, posx-16, posy-1, posx, posy-17, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, posx-16, posy+1, posx, posy-15, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, posx, posy+32, posx-16, posy+16, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, posx, posy+31, posx-16, posy+15, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, posx, posy+33, posx-16, posy+17, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, posx+sizex-16, posy-16, posx+sizex, posy, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, posx+sizex-16, posy-17, posx+sizex, posy-1, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, posx+sizex-16, posy-15, posx+sizex, posy+1, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, posx+sizex-16, posy+32, posx+sizex, posy+16, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, posx+sizex-16, posy+31, posx+sizex, posy+15, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, posx+sizex-16, posy+33, posx+sizex, posy+17, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, posx-16, posy, posy+16, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, posx-15, posy, posy+16, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, posx-17, posy, posy+16, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, posx+sizex, posy, posy+16, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, posx+sizex-1, posy, posy+16, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, posx+sizex+1, posy, posy+16, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, posx, posx+sizex-16, posy-16, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, posx, posx+sizex-16, posy-17, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, posx, posx+sizex-16, posy-15, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, posx, posx+sizex-16, posy+32, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, posx, posx+sizex-16, posy+31, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, posx, posx+sizex-16, posy+33, 0x7E, 0x7E, 0x7E);
	sge_tt_textout(buffer, font, message, posx, posy+16, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
}

static void bat_draw_ur(SDL_Surface * screen)	{
	sge_Line(buffer, 288, 16, 304, 32, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 288, 15, 304, 31, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 288, 17, 304, 33, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 480, 16, 496, 32, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 480, 15, 496, 31, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 480, 17, 496, 33, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 32, 624, 48, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 608, 31, 624, 47, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 33, 624, 49, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 149, 624, 165, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 608, 148, 624, 164, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 150, 624, 166, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 266, 624, 282, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 608, 265, 624, 281, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 267, 624, 283, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 383, 624, 399, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 608, 382, 624, 398, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 384, 624, 400, 0x7E, 0x7E, 0x7E);
}

static void bat_draw_ul(SDL_Surface * screen)	{
	sge_Line(buffer, 16, 32, 32, 16, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 16, 31, 32, 15, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 16, 33, 32, 17, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 336, 32, 352, 16, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 336, 31, 352, 15, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 336, 33, 352, 17, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 528, 48, 544, 32, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 528, 47, 544, 31, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 528, 49, 544, 33, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 528, 165, 544, 149, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 528, 164, 544, 148, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 528, 166, 544, 150, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 528, 282, 544, 266, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 528, 281, 544, 265, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 528, 283, 544, 267, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 528, 399, 544, 383, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 528, 398, 544, 382, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 528, 400, 544, 384, 0x7E, 0x7E, 0x7E);
}

static void bat_draw_lr(SDL_Surface * screen)	{
	sge_Line(buffer, 288, 288, 304, 272, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 288, 287, 304, 271, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 288, 289, 304, 273, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 480, 288, 496, 272, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 480, 287, 496, 271, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 480, 289, 496, 273, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 117, 624, 101, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 608, 116, 624, 100, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 118, 624, 102, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 234, 624, 218, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 608, 233, 624, 217, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 235, 624, 219, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 351, 624, 335, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 608, 350, 624, 334, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 352, 624, 336, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 468, 624, 452, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 608, 467, 624, 451, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 608, 469, 624, 453, 0x7E, 0x7E, 0x7E);
}

static void bat_draw_ll(SDL_Surface * screen)	{
	sge_Line(buffer, 32, 288, 16, 272, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 32, 287, 16, 271, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 32, 289, 16, 273, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 352, 288, 336, 272, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 352, 287, 336, 271, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 352, 289, 336, 273, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 544, 117, 528, 101, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 544, 116, 528, 100, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 544, 118, 528, 102, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 544, 234, 528, 218, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 544, 233, 528, 217, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 544, 235, 528, 219, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 544, 351, 528, 335, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 544, 350, 528, 334, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 544, 352, 528, 336, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 544, 468, 528, 452, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 544, 467, 528, 451, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 544, 469, 528, 453, 0x7E, 0x7E, 0x7E);
}

static void bat_draw_horiz(SDL_Surface * screen)	{
	sge_HLine(buffer, 32, 288, 16, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 32, 288, 15, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 32, 288, 17, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 352, 480, 16, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 352, 480, 15, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 352, 480, 17, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 32, 288, 288, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 32, 288, 287, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 32, 288, 289, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 352, 480, 288, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 352, 480, 287, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 352, 480, 289, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 32, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 544, 608, 31, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 33, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 117, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 544, 608, 116, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 118, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 149, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 544, 608, 148, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 150, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 234, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 544, 608, 233, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 235, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 266, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 544, 608, 265, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 267, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 351, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 544, 608, 350, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 352, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 383, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 544, 608, 382, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 384, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 468, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 544, 608, 467, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 544, 608, 469, 0x7E, 0x7E, 0x7E);
}

static void bat_draw_vert(SDL_Surface * screen)	{
	sge_VLine(buffer, 16, 32, 272, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 15, 32, 272, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 17, 32, 272, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 304, 32, 272, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 303, 32, 272, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 305, 32, 272, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 336, 32, 272, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 335, 32, 272, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 337, 32, 272, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 496, 32, 272, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 495, 32, 272, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 497, 32, 272, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 528, 48, 101, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 527, 48, 101, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 529, 48, 101, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 624, 48, 101, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 623, 48, 101, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 625, 48, 101, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 528, 165, 218, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 527, 165, 218, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 529, 165, 218, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 624, 165, 218, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 623, 165, 218, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 625, 165, 218, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 528, 282, 335, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 527, 282, 335, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 529, 282, 335, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 624, 282, 335, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 623, 282, 335, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 625, 282, 335, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 528, 399, 452, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 527, 399, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 529, 399, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 624, 399, 452, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 623, 399, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 625, 399, 452, 0x7E, 0x7E, 0x7E);
}


static void bat_draw_enemies(SDL_Surface * screen)	{
	SDL_Rect rect;
	if(enemies[0].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 49, 49);
		SDL_BlitSurface(enemies[0].images.splayer, NULL, buffer, &rect);
	}
	if(enemies[1].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 49, 123);
		SDL_BlitSurface(enemies[1].images.splayer, NULL, buffer, &rect);
	}
	if(enemies[2].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 49, 197);
		SDL_BlitSurface(enemies[2].images.splayer, NULL, buffer, &rect);
	}
	if(enemies[3].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 128, 49);
		SDL_BlitSurface(enemies[3].images.splayer, NULL, buffer, &rect);
	}
	if(enemies[4].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 128, 123);
		SDL_BlitSurface(enemies[4].images.splayer, NULL, buffer, &rect);
	}
	if(enemies[5].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 128, 197);
		SDL_BlitSurface(enemies[5].images.splayer, NULL, buffer, &rect);
	}
	if(enemies[6].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 208, 49);
		SDL_BlitSurface(enemies[6].images.splayer, NULL, buffer, &rect);
	}
	if(enemies[7].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 208, 123);
		SDL_BlitSurface(enemies[7].images.splayer, NULL, buffer, &rect);
	}
	if(enemies[8].stats.hp_rem != 0)	{
		rect = rect_set(72, 72, 208, 197);
		SDL_BlitSurface(enemies[8].images.splayer, NULL, buffer, &rect);
	}
}

static void bat_draw_player(SDL_Surface * screen)	{
	SDL_Rect rect;
	if(stats[0].stats.hp_rem != 0)	{
		rect = rect_set(32, 32, 464, 48);
		SDL_BlitSurface(stats[0].images.splayer, NULL, buffer, &rect);
	}

	if(stats[1].stats.hp_rem != 0)	{
		rect = rect_set(32, 32, 464, 104);
		SDL_BlitSurface(stats[1].images.splayer, NULL, buffer, &rect);
	}

	if(stats[2].stats.hp_rem != 0)	{
		rect = rect_set(32, 32, 464, 160);
		SDL_BlitSurface(stats[2].images.splayer, NULL, buffer, &rect);
	}

	if(stats[3].stats.hp_rem != 0)	{
		rect = rect_set(32, 32, 464, 216);
		SDL_BlitSurface(stats[3].images.splayer, NULL, buffer, &rect);
	}

}

static void bat_draw_menu(SDL_Surface * screen)	{
	sge_Line(buffer, 32, 304, 16, 320, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 32, 303, 16, 319, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 32, 305, 16, 321, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 200, 304, 184, 320, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 200, 303, 184, 319, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 200, 306, 184, 321, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 16, 452, 32, 468, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 16, 451, 32, 467, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 16, 453, 32, 469, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 452, 200, 468, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 184, 451, 200, 467, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 453, 200, 469, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 152, 304, 168, 320, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 152, 303, 168, 319, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 152, 305, 168, 321, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 480, 304, 496, 320, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 480, 303, 496, 319, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 480, 305, 496, 321, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 168, 452, 152, 468, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 168, 451, 152, 467, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 168, 453, 152, 469, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 496, 452, 480, 468, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 496, 451, 480, 467, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 496, 453, 480, 469, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 16, 320, 452, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 15, 320, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 17, 320, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 168, 320, 452, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 167, 320, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 169, 320, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 184, 320, 452, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 183, 320, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 185, 320, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 496, 320, 452, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 495, 320, 452, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 497, 320, 452, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 32, 152, 304, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 32, 152, 303, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 32, 152, 305, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 32, 152, 468, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 32, 152, 467, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 32, 152, 469, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 480, 304, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 200, 480, 303, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 480, 305, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 480, 468, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 200, 480, 467, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 480, 469, 0x7E, 0x7E, 0x7E);
}

static void bat_draw_mp(SDL_Surface * screen)	{
	sge_TTF_SetFontSize(font, 12);
	stats[0].stats.mpc = (char *) malloc(10);
	stats[1].stats.mpc = (char *) malloc(10);
	stats[2].stats.mpc = (char *) malloc(10);
	stats[3].stats.mpc = (char *) malloc(10);
	sprintf(stats[0].stats.mpc, "%d/%d", stats[0].stats.mp_rem, stats[0].stats.mp);
	sprintf(stats[1].stats.mpc, "%d/%d", stats[1].stats.mp_rem, stats[1].stats.mp);
	sprintf(stats[2].stats.mpc, "%d/%d", stats[2].stats.mp_rem, stats[2].stats.mp);
	sprintf(stats[3].stats.mpc, "%d/%d", stats[3].stats.mp_rem, stats[3].stats.mp);
	sge_tt_textout(buffer, font, stats[0].stats.mpc, 544, 96, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[1].stats.mpc, 544, 214, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[2].stats.mpc, 544, 331, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[3].stats.mpc, 544, 446, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	for(int i = 0; i <= 0; i++)
		free(stats[i].stats.mpc);
}

static void bat_draw_hp(SDL_Surface * screen)	{
	sge_TTF_SetFontSize(font, 12);
	stats[0].stats.hpc = (char *) malloc(10);
	stats[1].stats.hpc = (char *) malloc(10);
	stats[2].stats.hpc = (char *) malloc(10);
	stats[3].stats.hpc = (char *) malloc(10);
	sprintf(stats[0].stats.hpc, "%d/%d", stats[0].stats.hp_rem, stats[0].stats.hp);
	sprintf(stats[1].stats.hpc, "%d/%d", stats[1].stats.hp_rem, stats[1].stats.hp);
	sprintf(stats[2].stats.hpc, "%d/%d", stats[2].stats.hp_rem, stats[2].stats.hp);
	sprintf(stats[3].stats.hpc, "%d/%d", stats[3].stats.hp_rem, stats[3].stats.hp);
	sge_tt_textout(buffer, font, stats[0].stats.hpc, 544, 80, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[1].stats.hpc, 544, 198, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[2].stats.hpc, 544, 315, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[3].stats.hpc, 544, 432, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	for(int i = 0; i <= 0; i++)
		free(stats[i].stats.hpc);
}

static void bat_draw_names(SDL_Surface * screen)	{
	sge_TTF_SetFontSize(font, 16);
	sge_tt_textout(buffer, font, stats[0].name, 544, 60, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[1].name, 544, 177, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[2].name, 544, 294, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[3].name, 544, 411, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
}

static void bat_draw_enemyn(SDL_Surface * screen)	{
	int x = 232;
	int y = 340;
	int i, j = 0;
	sge_TTF_SetFontSize(font, 20);
	for(i = 0; i < 9; i++)
		en_menu[i] = -1;

	for(i = 0; i < 9; i++)	{
		if(enemies[i].stats.hp_rem != 0)	{
			sge_tt_textout(buffer, font, enemies[i].name, x, y, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
			y += 20;
			if(y > 420)	{
				y = 340;
				x = 364;
			}
			en_menu[j] = i;
			j++;
		}
	}
}

static void bat_draw_options(SDL_Surface * screen)	{
	sge_TTF_SetFontSize(font, 20);
	sge_tt_textout(buffer, font, "Attack", 64, 340, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Magic", 64, 360, 0x7E, 0x7E, 0x7E, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Skill", 64, 380, 0x7E, 0x7E, 0x7E, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Item", 64, 400, 0x7E, 0x7E, 0x7E, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Defend", 64, 420, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Run", 64, 440, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
}

inline static void bat_refresh(SDL_Surface * screen)	{
	SDL_Rect bot_rect;
	bot_rect = rect_set(640, 480, 0, 0);
	SDL_FillRect(buffer, &bot_rect, SDL_MapRGB(screen->format, 0x00, 0x00, 0x00));
	bat_draw_ur(screen);
	bat_draw_ul(screen);
	bat_draw_lr(screen);
	bat_draw_ll(screen);
	bat_draw_horiz(screen);
	bat_draw_vert(screen);
	bat_draw_names(screen);
	bat_draw_hp(screen);
	bat_draw_mp(screen);
	bat_draw_enemies(screen);
	bat_draw_player(screen);
}

inline static void bat_menu_changed(SDL_Surface * screen)	{
	/* Draw the new arrow */
	int point = 320 + (sel1 * 20);
	sge_FilledTrigon(buffer, col, point, col, point+20, col+16, point+10, 0xFF, 0xFF, 0xFF);
}

static void bat_show_term(SDL_Surface * screen, stat_data_t * def, stat_data_t * att)	{
	sge_Line(buffer, 184, 452, 200, 436, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 184, 451, 200, 435, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 453, 200, 437, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 452, 200, 468, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 184, 451, 200, 467, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 453, 200, 469, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 436, 386, 452, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 370, 435, 386, 451, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 437, 386, 453, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 468, 386, 452, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 370, 467, 386, 451, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 469, 386, 453, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 436, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 200, 370, 435, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 437, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 468, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 200, 370, 467, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 469, 0x7E, 0x7E, 0x7E);
	sge_TTF_SetFontSize(font, 16);
	if(def->ally == -1)	{
		sge_tt_textout(buffer, font, "Terminated", 216, 458, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
		att->bat.kills++;
		exper += def->stats.exp;
	}
	else	{
		sge_tt_textout(buffer, font, "Slain", 216, 458, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
		def->bat.defeats++;
	}
}

static void bat_show_damage(SDL_Surface * screen, unsigned int damage, stat_data_t *att, stat_data_t *def)	{
	char string[40];

	bat_message(screen, 32, 320, 136, att->name);
	sge_Line(buffer, 184, 320, 200, 304, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 184, 319, 200, 303, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 321, 200, 305, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 380, 200, 364, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 184, 379, 200, 363, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 381, 200, 365, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 336, 200, 352, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 184, 335, 200, 351, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 336, 200, 353, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 396, 200, 412, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 184, 395, 200, 411, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 184, 397, 200, 413, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 304, 386, 320, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 370, 303, 386, 319, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 305, 386, 321, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 364, 386, 380, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 370, 363, 386, 379, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 365, 386, 381, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 352, 386, 336, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 370, 351, 386, 335, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 353, 386, 337, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 412, 386, 396, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 370, 411, 386, 395, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 370, 413, 386, 397, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 184, 320, 336, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 183, 320, 336, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 185, 320, 336, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 386, 320, 336, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 385, 320, 336, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 387, 320, 336, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 184, 380, 396, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 183, 380, 396, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 185, 380, 396, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 386, 380, 396, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 385, 380, 396, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 387, 380, 396, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 304, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 200, 370, 303, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 305, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 352, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 200, 370, 351, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 353, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 364, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 200, 370, 363, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 365, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 412, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 200, 370, 411, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 200, 370, 413, 0x7E, 0x7E, 0x7E);

 	sge_TTF_SetFontSize(font, 16);
	sge_tt_textout(buffer, font, def->name, 216, 334, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);
	if(damage > 1)
		sprintf(string, "%d damages", damage);

	if(damage == 1)
		sprintf(string, "%d damage", damage);

	sge_tt_textout(buffer, font, string, 216, 394, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE);

	if(damage >= def->stats.hp_rem)
		bat_show_term(screen, def, att);

	SDL_BlitSurface(buffer, NULL, screen, NULL);
	SDL_Flip(screen);

	bat_draw_enemies(screen);
	bat_draw_player(screen);
}

static void bat_att_damage(SDL_Surface * screen, stat_data_t * att, stat_data_t * def)	{
	int res, res1;
	res = sge_Random(att->stats.attack, att->stats.attack * 2) - def->stats.defense;

	if(res < 1)
		res = 1;

	if(def->battle.defend == 1 && res != 1)
		floor(res /= 2);

	if(res > def->stats.hp_rem)	{
		bat_show_damage(screen, res, att, def);
		SDL_Delay(2000);
		def->stats.hp_rem = 0;
	}
	else	{
		bat_show_damage(screen, res, att, def);
		SDL_Delay(2000);
		res1 = def->stats.hp_rem - res;
		def->stats.hp_rem = res1;
	}
}

static void bat_enemy_ai(SDL_Surface * screen, stat_data_t * estat)	{
	unsigned int rand1, rand2, ally;
	unsigned int i = 0;
	/* These two lines are only here to suppress compiler warnings */
	rand1 = sge_Random(0, 9);
	rand2 = sge_Random(0, 7);
	if(estat->stats.speed != 0 && estat->stats.hp_rem != 0)	{
		while(i != estat->stats.speed + estat->stats.hp_rem)	{
			rand1 = sge_Random(0, 9);
			i++;
		}
		i = 0;
		if(rand1 >= 0)	{
			while(i != estat->stats.hp_rem + rand1)	{
				rand2 = sge_Random(0, 7);
				i++;
			}
			rand2 = sge_Random(0, 7);

			if(rand2 <= 2)
				ally = 0;
			else if(rand2 <= 5)
				ally = 1;
			else if(rand2 == 6)
				ally = 2;
			else
				ally = 3;

			while(stats[ally].stats.hp_rem == 0)	{
				if(ally != 0)
					ally -= 1;
				else
					ally = 3;
			}
			bat_att_damage(screen, estat, &stats[ally]);
		}
	}
}

static void bat_order()	{
	unsigned int i = 50;
	unsigned int l = 0;
	while(i > 0)	{
		if(i == stats[0].stats.speed)	{
			p[l] = &stats[0];
			l++;
		}
		if(i == stats[1].stats.speed)	{
			p[l] = &stats[1];
			l++;
		}
		if(i == stats[2].stats.speed)	{
			p[l] = &stats[2];
			l++;
		}
		if(i == stats[3].stats.speed)	{
			p[l] = &stats[3];
			l++;
		}
		if(i == enemies[0].stats.speed)	{
			p[l] = &enemies[0];
			l++;
		}
		if(i == enemies[1].stats.speed)	{
			p[l] = &enemies[1];
			l++;
		}
		if(i == enemies[2].stats.speed)	{
			p[l] = &enemies[2];
			l++;
		}
		if(i == enemies[3].stats.speed)	{
			p[l] = &enemies[3];
			l++;
		}
		if(i == enemies[4].stats.speed)	{
			p[l] = &enemies[4];
			l++;
		}
		if(i == enemies[5].stats.speed)	{
			p[l] = &enemies[5];
			l++;
		}
		if(i == enemies[6].stats.speed)	{
			p[l] = &enemies[6];
			l++;
		}
		if(i == enemies[7].stats.speed)	{
			p[l] = &enemies[7];
			l++;
		}
		if(i == enemies[8].stats.speed)	{
			p[l] = &enemies[8];
			l++;
		}
		i--;

	}

}

static void bat_draw_indic(SDL_Surface * screen, stat_data_t * astat)	{
	int i, pos;
	for(i = 0; i < 4; i++)	{
		if(!strcmp(astat->name, stats[i].name))	{
			if(astat->stats.speed == stats[i].stats.speed)	{
				break;
			}
		}
	}

	if(i == 0)
		pos = 54;
	else if(i == 1)
		pos = 110;
	else if(i == 2)
		pos = 166;
	else
		pos = 221;

	sge_FilledTrigon(buffer, 432, pos, 432, pos+20, 448, pos+10, 0xFF, 0xFF, 0xFF);
}

static void bat_do_menu(SDL_Surface * screen, stat_data_t * astat)	{
	bat_refresh(screen);
	bat_draw_enemyn(screen);
	bat_draw_menu(screen);
	bat_draw_options(screen);
	SDL_Event event;
	int changed = 1;
	int menudone = 0;
	int counter = 0;
	SDL_PollEvent(NULL);
	while(menudone == 0)	{
	counter++;
	SDL_PollEvent(&event);
	switch(event.type)	{
		case SDL_KEYUP:
			switch(event.key.keysym.sym)	{
				case SDLK_DOWN:
				case SDLK_UP:
					direct = NONE;
					break;
			}
			break;

		case SDL_KEYDOWN:
			switch(event.key.keysym.sym)	{
				case SDLK_DOWN:
					sel1++;
					changed = 1;
					direct = DOWN;
					break;
				case SDLK_UP:
					sel1--;
					changed = 1;
					direct = UP;
					break;
				#ifdef DEBUG_VER
				case SDLK_ESCAPE:
					bat_done = 1;
					menudone = 1;
					direct = NONE;
					break;
				#endif
				case SDLK_RETURN:
					direct = NONE;
					if(en_menu[sel] != -1)	{
						if(col == 200 || col == 334 && action == ACTION_ATTACK)	{
							if(enemies[en_menu[sel]].stats.hp_rem != 0)	{
								bat_refresh(screen);
								bat_att_damage(screen, astat, &enemies[en_menu[sel]]);
								menudone = 1;
							}
						}
					}
					if(col == 32 && sel == 0)	{
						col = 200;
						action = ACTION_ATTACK;
						sel = 0;
						sel1 = 0;
						changed = 1;
					}
					if(col == 32 && sel == 4)	{
						bat_refresh(screen);
						action = ACTION_DEFEND;
						sel = 0;
						sel1 = 0;
						astat->battle.defend = 1;
						bat_message(screen, 32, 320, 136, astat->name);
						bat_message(screen, 202, 320, 136, "Defending");
						SDL_BlitSurface(buffer, NULL, screen, NULL);
						SDL_Flip(screen);
						SDL_Delay(5000);
						menudone = 1;

					}

					if(col == 32 && sel == 5)	{
						bat_refresh(screen);
						action = ACTION_RUN;
						sel = 0;
						sel1 = 0;
						sge_Randomize();
						int rand_en = sge_Random(0, 8);
						while(enemies[rand_en].stats.speed == 0 || enemies[rand_en].stats.hp_rem == 0)	{
							rand_en = sge_Random(0, 8);
						}

						if(astat->stats.speed > enemies[rand_en].stats.speed)	{
							bat_message(screen, 32, 320, 136, astat->name);
							bat_message(screen, 202, 320, 136, "Ran Away...");
							bat_done = 1;
							menudone = 1;
						}

						else if(astat->stats.speed < enemies[rand_en].stats.speed)	{
							bat_message(screen, 32, 320, 136, astat->name);
							bat_message(screen, 202, 320, 136, "Couldn't Run!");
							menudone = 1;
						}

						else if(astat->stats.speed == enemies[rand_en].stats.speed)	{
							rand_en = sge_Random(0, 1);
							bat_message(screen, 32, 320, 136, astat->name);
							if(rand_en == 0)	{
								bat_message(screen, 202, 320, 136, "Couldn't Run!");
							}
							else	{
								bat_message(screen, 202, 320, 136, "Ran Away...");
								bat_done = 1;
							}
							menudone = 1;
						}
						SDL_BlitSurface(buffer, NULL, screen, NULL);
						SDL_Flip(screen);
						SDL_Delay(5000);
					}
					break;
				case SDLK_LEFT:
					direct = NONE;
					if(col == 200)	{
						col = 32;
						sel = 0;
						sel1 = 0;
						changed = 1;
						action = ACTION_NONE;
					}
					if(col == 334)	{
						col = 200;
						sel -= 6;
						changed = 1;
					}
					break;
				case SDLK_RIGHT:
					direct = NONE;
					if(col == 200)	{
						col = 334;
						sel += 6;
						changed = 1;
					}
					break;
			}
			break;

		case SDL_JOYBUTTONDOWN:
			if(event.jbutton.button == 0)	{
				if(en_menu[sel] != -1)	{
					if(col == 200 || col == 334 && action == ACTION_ATTACK)	{
						if(enemies[en_menu[sel]].stats.hp_rem != 0)	{
							bat_refresh(screen);
							bat_att_damage(screen, astat, &enemies[en_menu[sel]]);
							menudone = 1;
						}
					}
				}
				if(col == 32 && sel == 0)	{
					col = 200;
					action = ACTION_ATTACK;
					sel = 0;
					sel1 = 0;
					changed = 1;
				}
				if(col == 32 && sel == 4)	{
					bat_refresh(screen);
					action = ACTION_DEFEND;
					sel = 0;
					sel1 = 0;
					astat->battle.defend = 1;
					bat_message(screen, 32, 320, 136, astat->name);
					bat_message(screen, 202, 320, 136, "Defending");
					SDL_BlitSurface(buffer, NULL, screen, NULL);
					SDL_Flip(screen);
					SDL_Delay(5000);
					menudone = 1;

				}
				if(col == 32 && sel == 5)	{
					bat_refresh(screen);
					action = ACTION_RUN;
					sel = 0;
					sel1 = 0;
					sge_Randomize();
					int rand_en = sge_Random(0, 8);
					while(enemies[rand_en].stats.speed == 0)	{
						rand_en = sge_Random(0, 8);
					}

					if(astat->stats.speed > enemies[rand_en].stats.speed)	{
						bat_message(screen, 32, 320, 136, astat->name);
						bat_message(screen, 202, 320, 136, "Ran Away...");
						bat_done = 1;
						menudone = 1;
					}

					else if(astat->stats.speed < enemies[rand_en].stats.speed)	{
						bat_message(screen, 32, 320, 136, astat->name);
						bat_message(screen, 202, 320, 136, "Couldn't Run!");
						menudone = 1;
					}

					else if(astat->stats.speed == enemies[rand_en].stats.speed)	{
						rand_en = sge_Random(0, 1);
						bat_message(screen, 32, 320, 136, astat->name);
						if(rand_en == 0)	{
							bat_message(screen, 202, 320, 136, "Couldn't Run!");
						}
						else	{
							bat_message(screen, 202, 320, 136, "Ran Away...");
							bat_done = 1;
						}
						menudone = 1;
					}
					SDL_BlitSurface(buffer, NULL, screen, NULL);
					SDL_Flip(screen);
					SDL_Delay(5000);
				}
			}
			break;

		case SDL_JOYHATMOTION:
			if(event.jhat.value == SDL_HAT_UP)	{
				sel1--;
				changed = 1;
			}
			if(event.jhat.value == SDL_HAT_DOWN)	{
				sel1++;
				changed = 1;
			}
			if(event.jhat.value == SDL_HAT_LEFT)	{
				direct = NONE;
				if(col == 200)	{
					col = 32;
					sel = 0;
					sel1 = 0;
					changed = 1;
					action = ACTION_NONE;
				}
				if(col == 334)	{
					col = 200;
					sel -= 6;
					changed = 1;
				}
			}
			if(event.jhat.value == SDL_HAT_RIGHT)	{
				direct = NONE;
				if(col == 200)	{
					col = 334;
					sel += 6;
					changed = 1;
				}
			}
			break;

		case SDL_JOYAXISMOTION:
			if(event.jaxis.axis == 0)	{
				if(event.jaxis.value > joyval)	{
					if(col == 200)	{
						col = 334;
						sel += 6;
						changed = 1;
					}
				}
				if(event.jaxis.value < -joyval)	{
					if(col == 200)	{
						col = 32;
						sel = 0;
						sel1 = 0;
						changed = 1;
						action = ACTION_NONE;
					}
					if(col == 334)	{
						col = 200;
						sel -= 6;
						changed = 1;
					}
				}
			}
			if(event.jaxis.axis == 1)	{
				if(event.jaxis.value > joyval)	{
					sel1++;
					changed = 1;
				}
				if(event.jaxis.value < -joyval)	{
					sel1--;
					changed = 1;
				}
			}
			break;
	}

	if(counter == 30 && direct == DOWN)	{
		sel1++;
		changed = 1;
		counter = 0;
	}

	if(counter == 30 && direct == UP)	{
		sel1++;
		changed = 1;
		counter = 0;
	}

	if(changed == 1)	{
		if(col == 32)	{
			if(sel1 > 5)	{
				sel1 = 0;
			}
			else if(sel1 < 0)	{
				sel1 = 5;
			}
			sel = sel1;
		}
		if(col == 200)	{
			if(sel1 > 4)	{
				sel1 = 0;
				sel = 5;
				col = 334;
			}
			else if(sel1 < 0)	{
				sel1 = 3;
				sel = 8;
				col = 334;
			}
			else	{
				sel = sel1;
			}
		}
		if(col == 334)	{
			if(sel1 > 3)	{
				sel1 = 0;
				sel = 0;
				col = 200;
			}
			if(sel1 < 0)	{
				sel1 = 4;
				sel = 4;
				col = 200;
			}
			else	{
				sel = sel1 + 5;
			}
		}
		bat_refresh(screen);

		bat_menu_changed(screen);
		bat_draw_enemyn(screen);
		bat_draw_menu(screen);
		bat_draw_options(screen);
		bat_draw_indic(screen, astat);
		SDL_BlitSurface(buffer, NULL, screen, NULL);
		SDL_Flip(screen);
		changed = 0;
		SDL_Delay(100);
	}
	}
	col = 32;
	sel1 = 0;
	sel = 0;
	action = ACTION_NONE;
	bat_refresh(screen);
}

static void bat_exper(SDL_Surface * screen)	{
	bat_refresh(screen);
	sge_TTF_SetFontSize(font, 16);
	sge_tt_textoutf(buffer, font,  32, 320, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE, "Gained %d experience!", exper);
	SDL_BlitSurface(buffer, NULL, screen, NULL);
	SDL_Flip(screen);
}

static void bat_do_bat(SDL_Surface * screen, Mix_Music * bvic)	{
	unsigned int l;
	SDL_Event event;
	int kill_ene = 0;
	int foo = 0;
	int j, k = 0;
	for(l = 0; l <= 12; l++)	{
		if(enemies[0].stats.hp_rem == 0 && enemies[1].stats.hp_rem == 0 &&
		   enemies[2].stats.hp_rem == 0 && enemies[3].stats.hp_rem == 0 &&
		   enemies[4].stats.hp_rem == 0 && enemies[5].stats.hp_rem == 0 &&
		   enemies[6].stats.hp_rem == 0 && enemies[7].stats.hp_rem == 0 &&
		   enemies[8].stats.hp_rem == 0)	{
		   	bat_done = 1;
		   	kill_ene = 1;
	   	}
	   	if(bat_done == 1)	{
		   	Mix_HaltMusic();
		   	if(kill_ene == 1)	{
			   	Mix_PlayMusic(bvic, -1);
			   	Mix_SetMusicPosition(2);
				for(j = 0; j < 4; j++)	{
					if(stats[j].stats.hp_rem > 0)	{
						k++;
					}
				}
				exper /= k;
				for(j = 0; j < 4; j++)	{
					if(stats[j].stats.hp_rem > 0)	{
						stats[j].stats.exp += exper;
					}
				}
				bat_exper(screen);
				while(foo == 0)	{
					SDL_PollEvent(&event);
					switch(event.type)	{
						case SDL_KEYDOWN:
							foo = 1;
							break;
						case SDL_JOYBUTTONDOWN:
							foo = 1;
							break;
					}
				}
				foo = 0;
				for(j = 0; j < 4; j++)	{
					SDL_Delay(100);
					if(stats[j].stats.exp >= (exp_to_level * pow(stats[j].stats.level, 2)))	{
						lev_level_up(&stats[j]);
						bat_refresh(screen);
						sge_TTF_SetFontSize(font, 16);
						sge_tt_textoutf(buffer, font,  32, 320, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, SDL_ALPHA_OPAQUE, "%s Leveled Up!", stats[j].name);
						SDL_BlitSurface(buffer, NULL, screen, NULL);
						SDL_Flip(screen);
						while(foo == 0)	{
							SDL_PollEvent(&event);
							switch(event.type)	{
								case SDL_KEYDOWN:
									foo = 1;
								break;
								case SDL_JOYBUTTONDOWN:
									foo = 1;
								break;
							}
						}
					}
				}
				Mix_HaltMusic();
				SDL_Delay(100);
			}
			exper = 0;
			Mix_FreeMusic(bvic);
		   	break;
	   	}
		if(p[l]->name == 0)	{
			break;
		}

		p[l]->battle.defend = 0;

		if(p[l]->ally == 1 && p[l]->stats.hp_rem != 0)	{
			bat_do_menu(screen, p[l]);
		}
		else if(p[l]->ally == -1)	{
			bat_refresh(screen);
			bat_enemy_ai(screen, p[l]);
		}

		bat_draw_hp(screen);
		bat_draw_mp(screen);
		bat_draw_enemies(screen);
		bat_draw_player(screen);
		SDL_BlitSurface(buffer, NULL, screen, NULL);
		SDL_Flip(screen);
	}
}

void do_battle(SDL_Surface * screen)	{
	SDL_Rect bot_rect;
	Mix_Music * music;
	Mix_Music * bvic;
	bat_done = 0;
	action = ACTION_NONE;
	direct = NONE;

	#ifdef RENDER_FAST
	sge_TTF_AAOff();
	#elif defined RENDER_NICE
	sge_TTF_AA_Alpha();
	#else
	sge_TTF_AAOn();
	#endif

	bot_rect = rect_set(640, 480, 0, 0);
	SDL_FillRect(screen, &bot_rect, SDL_MapRGB(screen->format, 0x00, 0x00, 0x00));
	SDL_Flip(screen);

	buffer = SDL_AllocSurface(SDL_SWSURFACE, 640, 480, 16, 0, 0, 0, 0);

	bat_order();
	for(int i = 0; i <= 3; i++)
		stats[i].battle.defend = 0;

	music = Mix_LoadMUS(BATMUS);
	bvic = Mix_LoadMUS(BTVMUS);
	Mix_PlayMusic(music, -1);
	Mix_SetMusicPosition(1);
	bat_draw_ur(screen);
	bat_draw_ul(screen);
	bat_draw_lr(screen);
	bat_draw_ll(screen);
	bat_draw_horiz(screen);
	bat_draw_vert(screen);
	bat_draw_names(screen);
	bat_draw_hp(screen);
	bat_draw_mp(screen);
	bat_draw_enemies(screen);
	bat_draw_player(screen);
	SDL_BlitSurface(buffer, NULL, screen, NULL);
	SDL_Flip(screen);
	while(bat_done == 0)	{
		sge_Randomize();
		bat_do_bat(screen, bvic);
	}
	Mix_FreeMusic(music);
	clear_screen(screen);
}
