/*  clean_code.h -- ljsdcdev
	Misc stuff
	ljsdcdev
	(c) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __CLEAN_CODE_H
#define __CLEAN_CODE_H

/* Make a rect */
inline SDL_Rect rect_set(int w, int h, int x, int y)	{
	SDL_Rect rect;
	rect.w = w;
	rect.h = h;
	rect.x = x;
	rect.y = y;
	return rect;
}

/* Stretcher */
inline SDL_Surface * ljsdcdev_stretch(SDL_Surface * src, float x, float y, float sizex, float sizey, Uint32 color)	{
	SDL_Surface * dst;
	float scalex, scaley;

	/* Calculate our scale factor */
	scalex = (sizex + 1)/ x;
	scaley = (sizey + 1)/ y;

	/* Use the appropriate rendering mode */
	#if defined RENDER_NICE
	dst = sge_transform_surface(src, color, 0, scalex, scaley, SGE_TAA);
	#elif defined RENDER_FAST
	dst = sge_transform_surface(src, color, 0, scalex, scaley, SGE_TTMAP);
	#else
	dst = sge_transform_surface(src, color, 0, scalex, scaley, 0);
	#endif

	return dst;
}

inline void clear_screen(SDL_Surface * screen)	{
	SDL_Rect screct;
	screct = rect_set(640, 480, 0, 0);
	SDL_FillRect(screen, &screct, SDL_MapRGB(screen->format, 0x00, 0x00, 0x00));
}

/* This'll be taken out soon, I hope */
inline void stats_setup()	{
	strcpy(stats[0].name, "L.J.");
	strcpy(stats[1].name, "Jon");
	strcpy(stats[2].name, "T.C.");
	strcpy(stats[3].name, "Nick");

	stats[0].stats.hp = 30;
	stats[0].stats.hp_rem = 30;
	stats[0].stats.attack = 9;
	stats[0].stats.speed = 9;
	stats[0].stats.defense = 7;

	stats[1].stats.hp = 25;
	stats[1].stats.hp_rem = 25;
	stats[1].stats.attack = 8;
	stats[1].stats.speed = 8;
	stats[1].stats.defense = 7;

	stats[2].stats.hp = 20;
	stats[2].stats.hp_rem = 20;
	stats[2].stats.speed = 7;
	stats[2].stats.attack = 7;
	stats[2].stats.defense = 6;

	stats[3].stats.hp = 21;
	stats[3].stats.hp_rem = 21;
	stats[3].stats.attack = 8;
	stats[3].stats.defense = 6;
	stats[3].stats.speed = 6;

	stats[0].stats.mp = 0;
	stats[0].stats.mp_rem = 0;

	stats[1].stats.mp = 0;
	stats[1].stats.mp_rem = 0;

	stats[2].stats.mp = 10;
	stats[2].stats.mp_rem = 10;

	stats[3].stats.mp = 10;
	stats[3].stats.mp_rem = 10;

	stats[0].ally = stats[1].ally = stats[2].ally = stats[3].ally = 1;

	stats[0].stats.rank = 0;
	stats[1].stats.rank = 1;
	stats[2].stats.rank = 2;
	stats[3].stats.rank = 3;

	stats[0].stats.level = 1;
	stats[1].stats.level = 1;
	stats[2].stats.level = 1;
	stats[3].stats.level = 1;

	stats[0].images.splayer = IMG_Load(P1);
	stats[1].images.splayer = IMG_Load(P2);
	stats[2].images.splayer = IMG_Load(P3);
	stats[3].images.splayer = IMG_Load(P4);

	/* Options */
	options.mc.r = 0x00;
	options.mc.g = 0x00;
	options.mc.b = 0xFF;

	options.tc.r = 0xFF;
	options.tc.g = 0xFF;
	options.tc.b = 0xFF;

	options.bc.r = 0xFF;
	options.bc.g = 0xFF;
	options.bc.b = 0xFF;
	options.bc.mr = 0x7E;
	options.bc.mg = 0x7E;
	options.bc.mb = 0x7E;
}

#endif /* !__CLEAN_CODE_H */
