/*	data.h -- ljsdcdev
	General purpose data structures
  	ljsdcdev
  	(c) 2002, 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __DATA_H
#define __DATA_H

#include "SDL.h"

typedef struct {
	char magname[16];
	unsigned int mlev;
	unsigned int mtyp;
	unsigned int mstr;
	unsigned int maff;
	unsigned int fmus;
	unsigned int bmus;
	unsigned int muse;
} mag_desc_t;

typedef struct {
	char skillname[16];
	unsigned int sstr;
	unsigned int saff;
	unsigned int fsus;
	unsigned int suse;
} skill_desc_t;

typedef struct {
	char eqname[10];
	signed int attplus;
	signed int defplus;
	signed int spdplus;
	signed int mdfplus;
	signed int matplus;
	signed int intplus;
	signed int accplus;
	unsigned int ndstr;
	unsigned int place;
} eq_desc_t;

typedef struct {
	char itname[10];
	unsigned int itaff;
	signed int attplus;
	signed int strplus;
	signed int defplus;
	signed int spdplus;
	signed int mdfplus;
	signed int matplus;
	signed int intplus;
	signed int accplus;
	signed int healthp;
	signed int magicpl;
	unsigned int batus;
	unsigned int fiuse;
} it_data_t;

typedef struct {
	char name[9];
	int ally;
	struct	{
		unsigned int attack;
		unsigned int defense;
		unsigned int speed;
		unsigned int strength;
		unsigned int mdef;
		unsigned int matt;
		unsigned int intel;
		unsigned int accuracy;
		unsigned int hp;
		unsigned int hp_rem;
		unsigned int mp;
		unsigned int mp_rem;
		char * hpc;
		char * mpc;
		unsigned int level;
		unsigned int exp;
		unsigned int exprem;
		unsigned int rank;
	} stats;
	struct	{
		mag_desc_t m11;
		mag_desc_t m12;
		mag_desc_t m21;
		mag_desc_t m22;
		mag_desc_t m31;
		mag_desc_t m32;
		mag_desc_t m41;
		mag_desc_t m42;
	} magic;
	struct	{
		skill_desc_t skill01;
		skill_desc_t skill02;
		skill_desc_t skill03;
		skill_desc_t skill04;
		skill_desc_t skill05;
	} skills;
	struct	{
		eq_desc_t weap;
		eq_desc_t armor;
		eq_desc_t head;
		eq_desc_t foot;
		eq_desc_t acc;
	} equip;
	struct	{
		SDL_Surface * splayer;
		SDL_Surface * aplayer[6];
		SDL_Surface * mplayer[6];
	} images;
	struct 	{
		int defend;
	} battle;
	struct	{
		int kills;
		int defeats;
	} bat;
} stat_data_t;

typedef struct	{
	char name[9];
	struct	{
		unsigned int attack;
		unsigned int defense;
		unsigned int speed;
		unsigned int strength;
		unsigned int mdef;
		unsigned int matt;
		unsigned int intel;
		unsigned int accuracy;
		unsigned int hp;
		unsigned int hp_rem;
		unsigned int mp;
		unsigned int mp_rem;
		unsigned int level;
		unsigned int exp;
		unsigned int exprem;
		unsigned int rank;
	} stats;
	struct	{
		mag_desc_t m11;
		mag_desc_t m12;
		mag_desc_t m21;
		mag_desc_t m22;
		mag_desc_t m31;
		mag_desc_t m32;
		mag_desc_t m41;
		mag_desc_t m42;
	} magic;
	struct	{
		skill_desc_t skill01;
		skill_desc_t skill02;
		skill_desc_t skill03;
		skill_desc_t skill04;
		skill_desc_t skill05;
	} skills;
	struct	{
		eq_desc_t weap;
		eq_desc_t armor;
		eq_desc_t head;
		eq_desc_t foot;
		eq_desc_t acc;
	} equip;
	struct	{
		int kills;
		int defeats;
	} bat;
} stats_data_t;

typedef struct	{
	struct	{
		Uint8 r;
		Uint8 g;
		Uint8 b;
	} mc;
	struct	{
		Uint8 r;
		Uint8 g;
		Uint8 b;
	} tc;
	struct	{
		Uint8 r;
		Uint8 g;
		Uint8 b;
		Uint8 mr;
		Uint8 mg;
		Uint8 mb;
	} bc;
} opt_t;

typedef struct	{
	struct {
		stats_data_t p1;
		stats_data_t p2;
		stats_data_t p3;
		stats_data_t p4;
	} stats;
	struct {
		unsigned int x;
		unsigned int y;
		unsigned int num;
	} map;
	it_data_t items[50];
	unsigned long time;
	unsigned long long gold;
	opt_t opts;
} save_data_t;

#endif /* ! __DATA_H */
