/*	ljsdcdev.h -- ljsdcdev
	Main includes, prototypes, defines, etc.
	ljsdcdev
	(c) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __LJSDCDEV_H
#define __LJSDCDEV_H
#include "SDL.h"
#include "data.h"
#include "SDL_image.h"
#include "sge.h"
#include "SDL_mixer.h"
#include <math.h>

#define RENDER_NICE
extern stat_data_t stats[4];
extern stat_data_t enemies[9];
extern it_data_t items[50];
extern opt_t options;
extern sge_TTFont * font;
extern int posx, posy, areanum;
extern int joyval;
extern int direct;
extern int count;
extern Mix_Music * tmmusic;

enum	{
	NONE,
	UP,
	DOWN,
	LEFT,
	RIGHT
};

extern int exp_to_level;

#ifdef _arch_dreamcast
#include <kos.h>

#define NO_CONT "/cd/images/cont.png"
#define DISC "/cd/images/discl.png"
#define LOGO "/cd/images/ljsdcdev.png"
#define ARROW "/cd/images/arrow.png"
#define MENU "/cd/images/menu.png"
#define P1 "/cd/images/fighter.png"
#define P2 "/cd/images/thief.png"
#define P3 "/cd/images/bkmage.png"
#define P4 "/cd/images/wtmage.png"
#define SMILY "/cd/images/smily.png"
#define FROWNY "/cd/images/frowny.png"
#define ANGRY "/cd/images/angry.png"
#define BLANK "/cd/images/blank.png"
#define FONT "/cd/fonts/axaxax.ttf"
#define TESTMAP "/cd/maps/test.fmp"
#define BATMUS "/cd/music/bat.it"
#define MENMUS "/cd/music/menu.it"
#define TILMUS "/cd/music/tile.it"
#define BTVMUS "/cd/music/bat_vic.it"
#include "clean_code.h"
#include "zlib/zlib.h"

#else
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>

#define LOGO "images/ljsdcdev.png"
#define ARROW "images/arrow.png"
#define MENU "images/menu.png"
#define DISC "images/discl.png"
#define P1 "images/fighter.png"
#define P2 "images/thief.png"
#define P3 "images/bkmage.png"
#define P4 "images/wtmage.png"
#define SMILY "images/smily.png"
#define FROWNY "images/frowny.png"
#define ANGRY "images/angry.png"
#define BLANK "images/blank.png"
#define FONT "fonts/axaxax.ttf"
#define TESTMAP "maps/test.fmp"
#define BATMUS "music/bat.it"
#define MENMUS "music/menu.it"
#define TILMUS "music/tile.it"
#define BTVMUS "music/bat_vic.it"
#include "clean_code.h"
#include "zlib.h"
#endif

void do_battle(SDL_Surface * screen);
void do_tilemap(SDL_Surface * screen);
void menu_do_menu(SDL_Surface * screen);
void save_data(save_data_t * save, SDL_Surface * screen);
void read_data(save_data_t * save, SDL_Surface * screen);
void save_game(SDL_Surface * screen);
void load_game(SDL_Surface * screen);
void lev_level_up(stat_data_t * stats);
#endif
