/*	main.cpp -- ljsdcdev
	Startup Stuff, etc.
	ljsdcdev
	(c) 2002, 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"
stat_data_t stats[4];
stat_data_t enemies[9];
it_data_t items[50];
opt_t options;
sge_TTFont * font;
int joyval;
int direct = NONE;
int count = 0;
int exp_to_level = 25;

void menu_opt_menu(SDL_Surface * buffer, SDL_Surface * screen, int frommenu);

static void draw_discl(SDL_Surface * src)	{

	sge_TTF_SetFontSize(font, 32);
	sge_TTF_SetFontStyle(font, SGE_TTF_ITALIC);
	sge_tt_textout(src, font, "Disclaimer:", 200, 32, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_TTF_SetFontSize(font, 24);
	sge_TTF_SetFontStyle(font, SGE_TTF_NORMAL);
	sge_tt_textout(src, font, "The ljsdcdev project comes with", 32, 64, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "ABSOLUTELY NO WARRANTY and is", 32, 88, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "freely distributed under the", 32, 112, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "terms of the GNU General Public", 32, 136, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "license, see the file License.txt", 32, 160, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "for more information.", 32, 184, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "ljsdcdev is in no way associated", 32, 218, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "with or endorsed by Sega.", 32, 242, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "The ljsdcdev Project is", 32, 324, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "(c) 2002, 2003 by Lawrence Sebald", 32, 348, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "Visit http://ljsdcdev.sunsite.dk/", 32, 400, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "or http://ljsdcdev.sourceforge.net/", 32, 424, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "for more information.", 32, 448, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
	sge_tt_textout(src, font, "Press Start or Return to continue", 32, 276, 0xE2, 0x29, 0x0E, 0xE2, 0x29, 0x0E, SDL_ALPHA_OPAQUE);
}

void start_menu(SDL_Surface * screen)	{
	SDL_Surface * bgimage;
	SDL_Surface * buffer = SDL_AllocSurface(SDL_SWSURFACE, 640, 480, 16, 0, 0, 0, 0);
	SDL_Event event;
	int menudone = 0;
	int changed = 1;
	int start = 0;
	int alpha = 255;
	int direction = 0;
	int sel = 0;
	Uint32 tval = SDL_GetTicks();

	bgimage = IMG_Load(MENU);
	sge_TTF_SetFontSize(font, 32);

	while(menudone == 0)	{
		SDL_PollEvent(NULL);
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_RETURN:
						menudone = 1;
						break;
				}
				break;
			case SDL_JOYBUTTONDOWN:
				if(event.jbutton.button == 4)	{
					menudone = 1;
				}
				break;

		}

		if(SDL_GetTicks() >= tval + 10)	{
			if(alpha == 0)
				direction = 1;
			else if(alpha == 255)
				direction = 0;

			if(direction == 0)
				alpha -= 20;
			else
				alpha += 20;

			if(alpha < 0)
				alpha = 0;
			if(alpha > 255)
				alpha = 255;

			SDL_BlitSurface(bgimage, NULL, buffer, NULL);
			sge_tt_textout(buffer, font, "The ljsdcdev Project", 100, 100, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, SDL_ALPHA_OPAQUE);
			#ifdef _arch_dreamcast
			sge_tt_textout(buffer, font, "Press Start", 216, 256, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, alpha);
			#else
			sge_tt_textout(buffer, font, "Press Return", 216, 256, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, alpha);
			#endif
			SDL_BlitSurface(buffer, NULL, screen, NULL);
			SDL_Flip(screen);
			tval = SDL_GetTicks();
		}
	}
	SDL_Delay(250);
	menudone = 0;

	while(menudone == 0)	{
		SDL_PollEvent(NULL);
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_RETURN:
						if(sel == 0)
							do_tilemap(screen);
						else if(sel == 1)	{
							load_game(screen);
							do_tilemap(screen);
						}
						else if(sel == 2)	{
							menu_opt_menu(buffer, screen, 0);
							changed = 1;
						}
						break;
					case SDLK_UP:
						sel--;
						changed = 1;
						break;
					case SDLK_DOWN:
						sel++;
						changed = 1;
						break;
				}
				break;
			case SDL_JOYHATMOTION:
				if(event.jhat.value == SDL_HAT_DOWN)	{
					sel++;
					changed = 1;
				}
				else if(event.jhat.value == SDL_HAT_UP)	{
					sel--;
					changed = 1;
				}
				break;
			case SDL_JOYBUTTONDOWN:
				if(event.jbutton.button == 4 || event.jbutton.button == 0)	{
					if(sel == 0)
						do_tilemap(screen);
					else if(sel == 1)	{
						load_game(screen);
						do_tilemap(screen);
					}
					else if(sel == 2)	{
						menu_opt_menu(buffer, screen, 0);
						changed = 1;
					}
				}
				break;
		}

		if(sel < 0)
			sel = 3;
		else if(sel > 3)
			sel = 0;

		if(changed == 1)	{
			sge_TTF_SetFontSize(font, 32);
			SDL_BlitSurface(bgimage, NULL, buffer, NULL);
			sge_tt_textout(buffer, font, "The ljsdcdev Project", 100, 100, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, SDL_ALPHA_OPAQUE);
			sge_FilledRectAlpha(buffer, 200, 224, 440, 352, SDL_MapRGB(buffer->format, 0x00, 0x00, 0xFF), 127);
			sge_tt_textout(buffer, font, "New Game", 216, 256, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, 200);
			sge_tt_textout(buffer, font, "Load", 216, 288, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, 200);
			sge_tt_textout(buffer, font, "Options", 216, 320, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, 200);
			sge_tt_textout(buffer, font, "Credits", 216, 352, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, 200);
			sge_FilledRectAlpha(buffer, 200, (sel * 32) + 224, 440, (sel * 32) + 256, SDL_MapRGB(buffer->format, 0x00, 0xBB, 0xFF), 127);
			SDL_BlitSurface(buffer, NULL, screen, NULL);
			SDL_Flip(screen);
			changed = 0;
			SDL_Delay(100);
		}
	}
}

int main(int argc, char *argv[])	{
	Uint32 flags = SDL_HWSURFACE;
	SDL_Surface * screen, * image;
	SDL_Joystick * cont1;

	if(SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER | SDL_INIT_AUDIO) < 0)	{
		return -1;
	}
	#ifndef _arch_dreamcast
	atexit(SDL_Quit);
	#endif

	if(sge_TTF_Init() != 0)	{
		return -1;
	}

	font = sge_TTF_OpenFont(FONT, 16);

	#ifdef RENDER_FAST
	sge_TTF_AAOff();
	#elif defined RENDER_NICE
	sge_TTF_AA_Alpha();
	#else
	sge_TTF_AAOn();
	#endif

	Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 2048);
	#ifndef _arch_dreamcast
	atexit(Mix_CloseAudio);
	#endif

	stats_setup();

	/* set up minimum joystick axis values */
	#ifdef _arch_dreamcast
	joyval = 13;
	#else
	joyval = 6535;
	#endif

	/* Set our video mode to 640x480 16bpp */
	screen = SDL_SetVideoMode(640, 480, 16, flags);

	/* Give our window a title */
	SDL_WM_SetCaption("ljsdcdev Demo 3", NULL);

	/* Enable Joystick */
	SDL_InitSubSystem(SDL_INIT_JOYSTICK);
	SDL_JoystickEventState(SDL_ENABLE);
	cont1 = SDL_JoystickOpen(0);

	/* Load up disclaimer */
	image = IMG_Load(DISC);

	/* Put up the Disclaimer */
	SDL_BlitSurface(image, NULL, screen, NULL);
	draw_discl(screen);
	SDL_Flip(screen);

	/* Display the disclaimer until start is pressed */
	int done = 0;
	SDL_Event event;
	while(done != 1)	{
		while(SDL_PollEvent(&event))	{
			switch(event.type)	{
				case SDL_KEYDOWN:
					switch(event.key.keysym.sym)	{
						case SDLK_RETURN:
							done = 1;
							break;
					}
					break;

					case SDL_JOYBUTTONDOWN:
					if(event.jbutton.button == 4)	{
						done = 1;
					}
				break;
			}
		}
	}
	/* Kill the image */
	SDL_FreeSurface(image);

	/* Load up the ljsdcdev logo */
	image = IMG_Load(LOGO);
	SDL_BlitSurface(image, NULL, screen, NULL);

	/* Display it for 5 seconds */
	SDL_Flip(screen);
	SDL_Delay(5000);

	/* Get rid of the image */
	SDL_FreeSurface(image);

	/* Do our start menu */
	start_menu(screen);

	SDL_FreeSurface(screen);
	SDL_Quit();
	return 0;
}
