/*	menu.cpp -- ljsdcdev
	In-game menu
	ljsdcdev
	(c) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"
static Mix_Music * memusic;
/* Declarations for submenus */
void menu_items_menu(SDL_Surface * buffer, SDL_Surface * screen);
void menu_opt_menu(SDL_Surface * buffer, SDL_Surface * screen, int frommenu);
void menu_stat_menu(SDL_Surface * buffer, SDL_Surface * screen, int partymem);

/* Yes, these are dummies for right now */
void menu_equip_menu(SDL_Surface * buffer, SDL_Surface * screen, int partymem){};
void menu_magic_menu(SDL_Surface * buffer, SDL_Surface * screen, int partymem){};
void menu_skill_menu(SDL_Surface * buffer, SDL_Surface * screen, int partymem){};

static void menu_draw_ul(SDL_Surface * buffer)	{
	sge_Line(buffer, 32, 48, 48, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 47, 48, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 49, 48, 33, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 32, 320, 48, 304, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 319, 48, 303, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 321, 48, 305, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 208, 48, 224, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 208, 47, 224, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 208, 49, 224, 33, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 208, 272, 224, 256, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 208, 271, 224, 255, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 208, 273, 224, 257, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 416, 48, 432, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 416, 47, 432, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 416, 49, 432, 33, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 416, 272, 432, 256, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 416, 271, 432, 255, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 416, 273, 432, 257, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_draw_ll(SDL_Surface * buffer)	{
	sge_Line(buffer, 32, 272, 48, 288, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 271, 48, 287, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 273, 48, 289, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 32, 432, 48, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 431, 48, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 433, 48, 449, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 208, 208, 224, 224, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 208, 207, 224, 223, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 208, 209, 224, 225, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 208, 432, 224, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 208, 431, 224, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 208, 433, 224, 449, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 416, 208, 432, 224, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 416, 207, 432, 223, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 416, 209, 432, 225, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 416, 432, 432, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 416, 431, 432, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 416, 433, 432, 449, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_draw_ur(SDL_Surface * buffer)	{
	sge_Line(buffer, 176, 32, 192, 48, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 176, 31, 192, 47, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 176, 33, 192, 49, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 176, 304, 192, 320, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 176, 303, 192, 319, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 176, 305, 192, 321, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 384, 32, 400, 48, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 384, 31, 400, 47, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 384, 33, 400, 49, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 384, 256, 400, 272, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 384, 255, 400, 271, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 384, 257, 400, 273, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 32, 608, 48, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 31, 608, 47, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 33, 608, 49, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 256, 608, 272, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 255, 608, 271, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 257, 608, 273, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_draw_lr(SDL_Surface * buffer)	{
	sge_Line(buffer, 176, 288, 192, 272, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 176, 287, 192, 271, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 176, 289, 192, 273, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 176, 448, 192, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 176, 447, 192, 431, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 176, 449, 192, 433, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 384, 224, 400, 208, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 384, 223, 400, 207, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 384, 225, 400, 209, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 384, 448, 400, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 384, 447, 400, 431, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 384, 449, 400, 433, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 224, 608, 208, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 223, 608, 207, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 225, 608, 209, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 448, 608, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 447, 608, 431, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 449, 608, 433, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_draw_hl(SDL_Surface * buffer)	{
	sge_HLine(buffer, 48, 176, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 176, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 176, 33, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 176, 288, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 176, 287, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 176, 289, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 48, 176, 304, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 176, 303, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 176, 305, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 176, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 176, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 176, 449, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 224, 384, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 224, 384, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 224, 384, 33, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 224, 384, 224, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 224, 384, 223, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 224, 384, 225, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 224, 384, 256, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 224, 384, 255, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 224, 384, 257, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 224, 384, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 224, 384, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 224, 384, 449, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 432, 592, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 432, 592, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 432, 592, 33, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 432, 592, 224, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 432, 592, 223, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 432, 592, 225, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 432, 592, 256, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 432, 592, 255, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 432, 592, 257, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 432, 592, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 432, 592, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 432, 592, 449, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_draw_vl(SDL_Surface * buffer)	{
	sge_VLine(buffer, 32, 48, 272, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 31, 48, 272, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 33, 48, 272, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 192, 48, 272, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 191, 48, 272, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 193, 48, 272, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 32, 320, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 31, 320, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 33, 320, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 192, 320, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 191, 320, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 193, 320, 432, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 208, 48, 208, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 207, 48, 208, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 209, 48, 208, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 400, 48, 208, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 399, 48, 208, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 401, 48, 208, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 208, 272, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 207, 272, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 209, 272, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 400, 272, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 399, 272, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 401, 272, 432, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 416, 48, 208, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 415, 48, 208, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 417, 48, 208, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 608, 48, 208, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 607, 48, 208, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 609, 48, 208, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 416, 272, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 415, 272, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 417, 272, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 608, 272, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 607, 272, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 609, 272, 432, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_draw_txt(SDL_Surface * buffer)	{
	sge_TTF_SetFontSize(font, 20);
	sge_TTF_SetFontStyle(font, SGE_TTF_NORMAL);
	sge_tt_textout(buffer, font, "Items", 64, 64, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Equip", 64, 96, options.bc.mr, options.bc.mg, options.bc.mb, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Magic", 64, 128, options.bc.mr, options.bc.mg, options.bc.mb, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Skills", 64, 160, options.bc.mr, options.bc.mg, options.bc.mb, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Stats", 64, 192, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Options", 64, 224, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, "Quit", 64, 256, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
}

static void menu_draw_names(SDL_Surface * buffer)	{
	sge_tt_textout(buffer, font, stats[0].name, 224, 112, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[1].name, 432, 112, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[2].name, 224, 336, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, stats[3].name, 432, 336, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
}

static void menu_draw_hp(SDL_Surface * buffer)	{
	char * hpc[4];
	hpc[0] = (char *) malloc(14);
	hpc[1] = (char *) malloc(14);
	hpc[2] = (char *) malloc(14);
	hpc[3] = (char *) malloc(14);
	sprintf(hpc[0], "HP: %d/%d", stats[0].stats.hp_rem, stats[0].stats.hp);
	sprintf(hpc[1], "HP: %d/%d", stats[1].stats.hp_rem, stats[1].stats.hp);
	sprintf(hpc[2], "HP: %d/%d", stats[2].stats.hp_rem, stats[2].stats.hp);
	sprintf(hpc[3], "HP: %d/%d", stats[3].stats.hp_rem, stats[3].stats.hp);
	sge_tt_textout(buffer, font, hpc[0], 224, 176, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, hpc[1], 432, 176, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, hpc[2], 224, 400, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, hpc[3], 432, 400, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	int i;
	for(i = 0; i < 4; i++)
		free(hpc[i]);
}

static void menu_draw_mp(SDL_Surface * buffer)	{
	char * mpc[4];
	mpc[0] = (char *) malloc(14);
	mpc[1] = (char *) malloc(14);
	mpc[2] = (char *) malloc(14);
	mpc[3] = (char *) malloc(14);
	sprintf(mpc[0], "MP: %d/%d", stats[0].stats.mp_rem, stats[0].stats.mp);
	sprintf(mpc[1], "MP: %d/%d", stats[1].stats.mp_rem, stats[1].stats.mp);
	sprintf(mpc[2], "MP: %d/%d", stats[2].stats.mp_rem, stats[2].stats.mp);
	sprintf(mpc[3], "MP: %d/%d", stats[3].stats.mp_rem, stats[3].stats.mp);
	sge_tt_textout(buffer, font, mpc[0], 224, 192, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, mpc[1], 432, 192, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, mpc[2], 224, 416, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textout(buffer, font, mpc[3], 432, 416, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	int i;
	for(i = 0; i < 4; i++)
		free(mpc[i]);
}

static void menu_draw_class(SDL_Surface * buffer)	{
	char cl[16];
	int i;
	for(i = 0; i < 4; i++)	{
		if(stats[i].stats.rank == 0)	{
			strcpy(cl, "Fighter");
		}
		else if(stats[i].stats.rank == 1)	{
			strcpy(cl, "Thief");
		}
		else if(stats[i].stats.rank == 2)	{
			strcpy(cl, "Black Mage");
		}
		else if(stats[i].stats.rank == 3)	{
			strcpy(cl, "White Mage");
		}

		if(i == 0)
			sge_tt_textout(buffer, font, cl, 224, 128, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
		else if(i == 1)
			sge_tt_textout(buffer, font, cl, 432, 128, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
		else if(i == 2)
			sge_tt_textout(buffer, font, cl, 224, 352, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
		else if(i == 3)
			sge_tt_textout(buffer, font, cl, 432, 352, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	}
}

static void menu_draw_lvl(SDL_Surface * buffer)	{
	sge_tt_textoutf(buffer, font, 224, 160, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Level %d", stats[0].stats.level);
	sge_tt_textoutf(buffer, font, 432, 160, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Level %d", stats[1].stats.level);
	sge_tt_textoutf(buffer, font, 224, 384, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Level %d", stats[2].stats.level);
	sge_tt_textoutf(buffer, font, 432, 384, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Level %d", stats[3].stats.level);
}

static void menu_draw_info(SDL_Surface * buffer)	{
	sge_TTF_SetFontSize(font, 18);
	sge_TTF_SetFontStyle(font, SGE_TTF_NORMAL);
	menu_draw_names(buffer);
	sge_TTF_SetFontSize(font, 16);
	menu_draw_hp(buffer);
	menu_draw_mp(buffer);
	menu_draw_class(buffer);
	menu_draw_lvl(buffer);
}

static void menu_draw_img(SDL_Surface * buffer)	{
	SDL_Rect prect;
	prect = rect_set(32, 32, 224, 48);
	SDL_BlitSurface(stats[0].images.splayer, NULL, buffer, &prect);
	prect = rect_set(32, 32, 432, 48);
	SDL_BlitSurface(stats[1].images.splayer, NULL, buffer, &prect);
	prect = rect_set(32, 32, 224, 272);
	SDL_BlitSurface(stats[2].images.splayer, NULL, buffer, &prect);
	prect = rect_set(32, 32, 432, 272);
	SDL_BlitSurface(stats[3].images.splayer, NULL, buffer, &prect);
}

static void menu_quit(SDL_Surface * buffer, SDL_Surface * screen)	{
	int quit = 0;
	int changed = 1;
	int sel = 1;
	SDL_Event event;
	SDL_Rect rect;
	sge_TTF_SetFontSize(font, 32);
	sge_TTF_SetFontStyle(font, SGE_TTF_NORMAL);
	while(quit == 0)	{
		SDL_PollEvent(NULL);
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_RIGHT:
						sel++;
						changed = 1;
						break;
					case SDLK_LEFT:
						sel--;
						changed = 1;
						break;
					case SDLK_RETURN:
						if(sel == 1)	{
							quit = 1;
						}
						if(sel == 0)	{
							Mix_FreeMusic(tmmusic);
							Mix_FreeMusic(memusic);
							#ifdef _arch_dreamcast
							arch_exit();
							#else
							exit(0);
							#endif
							quit = 1;
						}
						break;
				}
				break;
			case SDL_JOYHATMOTION:
				if(event.jhat.value == SDL_HAT_RIGHT)	{
					sel++;
					changed = 1;
				}
				if(event.jhat.value == SDL_HAT_LEFT)	{
					sel--;
					changed = 1;
				}
				break;
			case SDL_JOYAXISMOTION:
				if(event.jaxis.axis == 0)	{
					if(event.jaxis.value > joyval)	{
						sel++;
						changed = 1;
					}
					if(event.jaxis.value < -joyval)	{
						sel--;
						changed = 1;
					}
				}
				break;
			case SDL_JOYBUTTONDOWN:
				if(event.jbutton.button == 0)	{
					if(sel == 1)	{
						quit = 1;
					}
					if(sel == 0)	{
						Mix_FreeMusic(tmmusic);
						#ifdef _arch_dreamcast
						arch_exit();
						#else
						exit(0);
						#endif
						quit = 1;
					}
				}
				break;
		}
		if(sel > 1)
			sel = 0;
		if(sel < 0)
			sel = 1;
		if(changed == 1)	{
			rect = rect_set(640, 480, 0, 0);
			SDL_FillRect(buffer, &rect, SDL_MapRGB(buffer->format, options.mc.r, options.mc.g, options.mc.b));
			sge_tt_textout(buffer, font, "Are you sure you want to", 48, 200, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
			sge_tt_textout(buffer, font, "quit?", 256, 232, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
			sge_tt_textout(buffer, font, "Yes", 224, 368, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
			sge_tt_textout(buffer, font, "No", 340, 368, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
			int point = 304;
			if(sel == 0)
				point = 192;
			if(sel == 1)
				point = 304;
			sge_FilledTrigon(buffer, point, 336, point, 368, point + 20, 352, options.bc.r, options.bc.g, options.bc.b);
			SDL_BlitSurface(buffer, NULL, screen, NULL);
			SDL_Flip(screen);
			changed = 0;
			SDL_Delay(100);
		}
	}
}

static void menu_stat_sel(SDL_Surface * buffer, SDL_Surface * screen)	{
	int stdone = 0;
	int sel = 0;
	int changed = 1;
	SDL_Rect rect;
	SDL_Event event;
	SDL_Delay(200);
	while(stdone == 0)	{
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_UP:
						if(sel == 2)
							sel = 0;
						else if(sel == 3)
							sel = 1;
						changed = 1;
						break;
					case SDLK_DOWN:
						if(sel == 0)
							sel = 2;
						else if(sel == 1)
							sel = 3;
						changed = 1;
						break;
					case SDLK_LEFT:
						if(sel == 1)
							sel = 0;
						else if(sel == 3)
							sel = 2;
						changed = 1;
						break;
					case SDLK_RIGHT:
						if(sel == 0)
							sel = 1;
						else if(sel == 2)
							sel = 3;
						changed = 1;
						break;
					case SDLK_RETURN:
						menu_stat_menu(buffer, screen, sel);
						SDL_Delay(100);
						stdone = 1;
						break;
					case SDLK_ESCAPE:
						SDL_Delay(100);
						stdone = 1;
						break;
				}
				break;
			case SDL_JOYBUTTONDOWN:
				if(event.jbutton.button == 0)	{
					menu_stat_menu(buffer, screen, sel);
					SDL_Delay(100);
					stdone = 1;
				}
				if(event.jbutton.button == 1)	{
					SDL_Delay(100);
					stdone = 1;
				}
				break;
			case SDL_JOYHATMOTION:
				if(event.jhat.value == SDL_HAT_UP)	{
					if(sel == 2)
						sel = 0;
					else if(sel == 3)
						sel = 1;
					changed = 1;
				}
				if(event.jhat.value	== SDL_HAT_DOWN)	{
					if(sel == 0)
						sel = 2;
					else if(sel == 1)
						sel = 3;
					changed = 1;
				}
				if(event.jhat.value == SDL_HAT_RIGHT)	{
					if(sel == 0)
						sel = 1;
					else if(sel == 2)
						sel = 3;
					changed = 1;
				}
				if(event.jhat.value == SDL_HAT_LEFT)	{
					if(sel == 1)
						sel = 0;
					else if(sel == 3)
						sel = 2;
					changed = 1;
				}
				break;
			case SDL_JOYAXISMOTION:
				if(event.jaxis.axis == 1 && event.jaxis.value < -joyval)	{
					if(sel == 2)
						sel = 0;
					else if(sel == 3)
						sel = 1;
					changed = 1;
				}
				if(event.jaxis.axis == 1 && event.jaxis.value > joyval)	{
					if(sel == 0)
						sel = 2;
					else if(sel == 1)
						sel = 3;
					changed = 1;
				}
				if(event.jaxis.axis == 0 && event.jaxis.value > joyval)	{
					if(sel == 0)
						sel = 1;
					else if(sel == 2)
						sel = 3;
					changed = 1;
				}
				if(event.jaxis.axis == 0 && event.jaxis.value < -joyval)	{
					if(sel == 1)
						sel = 0;
					else if(sel == 3)
						sel = 2;
					changed = 1;
				}
				break;
		}
		if(changed == 1)	{
			rect = rect_set(640, 480, 0, 0);
			SDL_FillRect(buffer, &rect, SDL_MapRGB(buffer->format, options.mc.r, options.mc.g, options.mc.b));
			menu_draw_ul(buffer);
			menu_draw_ll(buffer);
			menu_draw_ur(buffer);
			menu_draw_lr(buffer);
			menu_draw_hl(buffer);
			menu_draw_vl(buffer);
			menu_draw_txt(buffer);
			menu_draw_img(buffer);
			menu_draw_info(buffer);
			if(sel == 0)	{
				sge_FilledTrigon(buffer, 288, 256, 320, 256, 304, 224, options.bc.r, options.bc.g, options.bc.b);
			}
			if(sel == 1)	{
				sge_FilledTrigon(buffer, 496, 256, 528, 256, 512, 224, options.bc.r, options.bc.g, options.bc.b);
			}
			if(sel == 2)	{
				sge_FilledTrigon(buffer, 288, 224, 320, 224, 304, 256, options.bc.r, options.bc.g, options.bc.b);
			}
			if(sel == 3)	{
				sge_FilledTrigon(buffer, 496, 224, 528, 224, 512, 256, options.bc.r, options.bc.g, options.bc.b);
			}
			SDL_BlitSurface(buffer, NULL, screen, NULL);
			SDL_Flip(screen);
			changed = 0;
			SDL_Delay(100);
		}
	}
}

static inline void menu_draw_arrow(SDL_Surface * buffer, int sel)	{
	int point = 45 + (sel * 32);
	sge_FilledTrigon(buffer, 40, point, 40, point+20, 56, point+10, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_main_loop(SDL_Surface * buffer, SDL_Surface * screen)	{
	int changed = 1;
	int stdone = 0;
	int sel = 0;
	int menudone = 0;
	SDL_Event event;
	SDL_Rect rect;
	while(menudone == 0)	{
		SDL_PollEvent(NULL);
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_UP:
						sel--;
						changed = 1;
						break;
					case SDLK_DOWN:
						sel++;
						changed = 1;
						break;
					case SDLK_RETURN:
						if(sel == 0)	{
							menu_items_menu(buffer, screen);
							changed = 1;
						}
						if(sel == 4)	{
							menu_stat_sel(buffer, screen);
							changed = 1;
						}
						if(sel == 5)	{
							menu_opt_menu(buffer, screen, 1);
							changed = 1;
						}
						if(sel == 6)	{
							menu_quit(buffer, screen);
							sel = 0;
							changed = 1;
						}
						break;
					case SDLK_ESCAPE:
						menudone = 1;
						break;
				}
				break;
			case SDL_JOYHATMOTION:
				if(event.jhat.value == SDL_HAT_UP)	{
					sel--;
					changed = 1;
				}
				if(event.jhat.value == SDL_HAT_DOWN)	{
					sel++;
					changed = 1;
				}
				break;
			case SDL_JOYAXISMOTION:
				if(event.jaxis.axis == 1)	{
					if(event.jaxis.value > joyval)	{
						sel++;
						changed = 1;
					}
					if(event.jaxis.value < -joyval)	{
						sel--;
						changed = 1;
					}
				}
				break;
			case SDL_JOYBUTTONDOWN:
				if(event.jbutton.button == 0)	{
					if(sel == 0)	{
						menu_items_menu(buffer, screen);
						changed = 1;
					}
					if(sel == 4)	{
						menu_stat_sel(buffer, screen);
						changed = 1;
					}
					if(sel == 5)	{
						menu_opt_menu(buffer, screen, 1);
						changed = 1;
					}
					if(sel == 6)	{
						menu_quit(buffer, screen);
						sel = 0;
						changed = 1;
					}
				}
				if(event.jbutton.button == 4 || event.jbutton.button == 1)	{
					menudone = 1;
				}
				break;
		}
		if(sel < 0)
			sel = 6;
		if(sel > 6)
			sel = 0;
		if(changed == 1)	{
			rect = rect_set(640, 480, 0, 0);
			SDL_FillRect(buffer, &rect, SDL_MapRGB(buffer->format, options.mc.r, options.mc.g, options.mc.b));
			menu_draw_ul(buffer);
			menu_draw_ll(buffer);
			menu_draw_ur(buffer);
			menu_draw_lr(buffer);
			menu_draw_hl(buffer);
			menu_draw_vl(buffer);
			menu_draw_txt(buffer);
			menu_draw_img(buffer);
			menu_draw_info(buffer);
			menu_draw_arrow(buffer, sel);
			SDL_BlitSurface(buffer, NULL, screen, NULL);
			SDL_Flip(screen);
			SDL_Delay(100);
			changed = 0;
		}
	}
}

void menu_do_menu(SDL_Surface * screen)	{
	SDL_Surface * buf;

	buf = SDL_AllocSurface(SDL_SWSURFACE, 640, 480, 16, 0, 0, 0, 0);
	memusic = Mix_LoadMUS(MENMUS);
	Mix_PlayMusic(memusic, -1);
	menu_main_loop(buf, screen);
}
