/*	sub_menu.cpp -- ljsdcdev
	In-game menu -- Submenus
	ljsdcdev
	(c) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

enum	{
	ITEM_NONE,
	ITEM_USE,
	ITEM_DROP
};

static void menu_items_ul(SDL_Surface * buffer)	{
	sge_Line(buffer, 32, 48, 48, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 47, 48, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 49, 48, 33, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 32, 128, 48, 112, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 127, 48, 111, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 129, 48, 113, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 160, 48, 176, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 160, 47, 176, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 160, 49, 176, 33, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 160, 208, 176, 192, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 160, 207, 176, 191, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 160, 209, 176, 193, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_items_ll(SDL_Surface * buffer)	{
	sge_Line(buffer, 32, 64, 48, 80, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 63, 48, 79, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 65, 48, 81, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 32, 160, 48, 176, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 159, 48, 175, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 161, 48, 177, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 160, 160, 176, 176, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 160, 159, 176, 175, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 160, 161, 176, 177, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 160, 432, 176, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 160, 431, 176, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 160, 433, 176, 449, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_items_ur(SDL_Surface * buffer)	{
	sge_Line(buffer, 128, 32, 144, 48, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 128, 31, 144, 47, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 128, 33, 144, 49, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 128, 112, 144, 128, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 128, 111, 144, 127, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 128, 113, 144, 129, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 32, 608, 48, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 31, 608, 47, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 33, 608, 49, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 192, 608, 208, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 191, 608, 207, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 193, 608, 209, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_items_lr(SDL_Surface * buffer)	{
	sge_Line(buffer, 128, 80, 144, 64, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 128, 79, 144, 63, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 128, 81, 144, 65, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 128, 176, 144, 160, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 128, 175, 144, 159, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 128, 177, 144, 161, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 176, 608, 160, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 175, 608, 159, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 177, 608, 161, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 448, 608, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 447, 608, 431, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 449, 608, 433, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_items_vl(SDL_Surface * buffer)	{
	sge_VLine(buffer, 32, 48, 64, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 31, 48, 64, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 33, 48, 64, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 144, 48, 64, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 143, 48, 64, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 145, 48, 64, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 32, 128, 160, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 31, 128, 160, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 33, 128, 160, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 144, 128, 160, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 143, 128, 160, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 145, 128, 160, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 160, 48, 160, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 159, 48, 160, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 161, 48, 160, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 608, 48, 160, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 607, 48, 160, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 609, 48, 160, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 160, 208, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 159, 208, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 161, 208, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 608, 208, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 607, 208, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 609, 208, 432, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_items_hl(SDL_Surface * buffer)	{
	sge_HLine(buffer, 48, 128, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 128, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 33, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 80, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 128, 79, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 81, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 48, 128, 112, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 128, 111, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 113, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 176, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 128, 175, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 177, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 176, 592, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 176, 592, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 33, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 176, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 176, 592, 175, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 177, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 176, 592, 192, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 176, 592, 191, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 193, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 176, 592, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 449, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_items_txt(SDL_Surface * buffer)	{
	sge_TTF_SetFontSize(font, 16);
	sge_TTF_SetFontStyle(font, SGE_TTF_NORMAL);
	sge_tt_textout(buffer, font, "Items", 48, 64, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
}

static inline void menu_items_arrow(SDL_Surface * buffer, int sel, int col)	{
}

void menu_items_menu(SDL_Surface * buffer, SDL_Surface * screen)	{
	SDL_Rect rect;
	SDL_Event event;
	int sel = 0, sel1 = 0;
	int col = 0;
	int op;
	int menudone = 0;
	int changed = 1;

	while(menudone == 0)	{
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_ESCAPE:
						menudone = 1;
						break;
					case SDLK_DOWN:
						sel++;
						changed = 1;
						break;
					case SDLK_UP:
						sel--;
						changed = 1;
						break;
					case SDLK_LEFT:
						if(col == 1)	{
							op = ITEM_NONE;
							sel = 0;
							col = 0;
						}
						if(col == 2)
							col = 1;
						if(col == 3)
							col = 2;
						break;
					case SDLK_RETURN:
						if(col == 0)	{
							sel = 0;
							col = 1;
							if(sel == 0)
								op = ITEM_USE;
							if(sel == 1)
								op = ITEM_DROP;
						}
						break;
				}
				break;
			case SDL_JOYBUTTONDOWN:
				if(event.jbutton.button == 4)	{
					menudone = 1;
				}
				if(event.jbutton.button == 1)	{
					menudone = 1;
				}
				break;
		}
		if(col == 0)	{
			if(sel < 0)
				sel = 1;
			if(sel > 1)
				sel = 0;
		}
		if(col == 1)	{
			sel1 = sel;
		}
		if(col == 2)	{
			sel1 = sel + 15;
		}
		if(col == 3)	{
			sel1 = sel + 30;
		}
		if(changed == 1)	{
			rect = rect_set(640, 480, 0, 0);
			SDL_FillRect(buffer, &rect, SDL_MapRGB(buffer->format, options.mc.r, options.mc.g, options.mc.b));
			menu_items_ur(buffer);
			menu_items_lr(buffer);
			menu_items_ul(buffer);
			menu_items_ll(buffer);
			menu_items_vl(buffer);
			menu_items_hl(buffer);
			menu_items_arrow(buffer, sel, col);
			menu_items_txt(buffer);
			SDL_BlitSurface(buffer, NULL, screen, NULL);
			SDL_Flip(screen);
			changed = 0;
		}

	SDL_Delay(100);
	}
}

static void menu_opt_st_draw(SDL_Surface * buffer)	{
	sge_Line(buffer, 32, 48, 48, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 47, 48, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 49, 48, 33, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 160, 48, 176, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 160, 47, 176, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 160, 49, 176, 33, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 128, 32, 144, 48, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 128, 31, 144, 47, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 128, 33, 144, 49, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 32, 608, 48, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 31, 608, 47, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 33, 608, 49, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 32, 64, 48, 80, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 32, 63, 48, 79, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 32, 65, 48, 81, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 160, 432, 176, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 160, 431, 176, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 160, 433, 176, 449, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 128, 80, 144, 64, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 128, 79, 144, 63, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 128, 81, 144, 65, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_Line(buffer, 592, 448, 608, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_Line(buffer, 592, 447, 608, 431, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_Line(buffer, 592, 449, 608, 433, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 48, 128, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 128, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 33, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 80, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 48, 128, 79, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 48, 128, 81, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_HLine(buffer, 176, 592, 32, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 176, 592, 31, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 33, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 448, options.bc.r, options.bc.g, options.bc.b);
	sge_HLine(buffer, 176, 592, 447, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_HLine(buffer, 176, 592, 449, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 32, 48, 64, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 31, 48, 64, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 33, 48, 64, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 144, 48, 64, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 143, 48, 64, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 145, 48, 64, options.bc.mr, options.bc.mg, options.bc.mb);

	sge_VLine(buffer, 160, 48, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 159, 48, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 161, 48, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 608, 48, 432, options.bc.r, options.bc.g, options.bc.b);
	sge_VLine(buffer, 607, 48, 432, options.bc.mr, options.bc.mg, options.bc.mb);
	sge_VLine(buffer, 609, 48, 432, options.bc.mr, options.bc.mg, options.bc.mb);
}

static void menu_opt_txt(SDL_Surface * buffer, int frommenu)	{
	sge_TTF_SetFontSize(font, 16);
	sge_TTF_SetFontStyle(font, SGE_TTF_NORMAL);
	sge_tt_textout(buffer, font, "Options", 48, 64, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);

	if(frommenu == 1)
		sge_tt_textout(buffer, font, "Save Game", 208, 64, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);

	sge_tt_textout(buffer, font, "Menu Color:", 224, 96, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textoutf(buffer, font, 208, 128, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Red: %d", options.mc.r);
	sge_tt_textoutf(buffer, font, 208, 144, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Green: %d", options.mc.g);
	sge_tt_textoutf(buffer, font, 208, 160, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Blue: %d", options.mc.b);

	sge_tt_textout(buffer, font, "Border Color:", 224, 192, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textoutf(buffer, font, 208, 224, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Red: %d", options.bc.r);
	sge_tt_textoutf(buffer, font, 208, 240, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Green: %d", options.bc.g);
	sge_tt_textoutf(buffer, font, 208, 256, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Blue: %d", options.bc.b);

	sge_tt_textout(buffer, font, "Text Color:", 224, 288, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textoutf(buffer, font, 208, 320, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Red: %d", options.tc.r);
	sge_tt_textoutf(buffer, font, 208, 336, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Green: %d", options.tc.g);
	sge_tt_textoutf(buffer, font, 208, 352, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Blue: %d", options.tc.b);
	if(frommenu == 1)
		sge_tt_textout(buffer, font, "Load Game", 208, 384, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
}


static inline void menu_opt_arrow(SDL_Surface * buffer, int sel)	{
	int point = 64;
	if(sel == 0)
		point = 64;
	else if(sel == 1)
		point = 128;
	else if(sel == 2)
		point = 144;
	else if(sel == 3)
		point = 160;
	else if(sel == 4)
		point = 224;
	else if(sel == 5)
		point = 240;
	else if(sel == 6)
		point = 256;
	else if(sel == 7)
		point = 320;
	else if(sel == 8)
		point = 336;
	else if(sel == 9)
		point = 352;
	else if(sel == 10)
		point = 384;

	sge_FilledTrigon(buffer, 176, point - 16, 176, point, 192, point - 8, options.bc.r, options.bc.g, options.bc.b);
}

void menu_opt_menu(SDL_Surface * buffer, SDL_Surface * screen, int frommenu)	{
	SDL_Rect rect;
	SDL_Event event;
	int changed = 1;
	int sel;
	int menudone = 0;

	if(frommenu == 1)
		sel = 0;
	else
		sel = 1;

	while(menudone == 0)	{
		SDL_PollEvent(NULL);
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_RETURN:
						if(frommenu == 1)	{
							if(sel == 0)
								save_game(screen);
							if(sel == 10)
								load_game(screen);
						}
						break;
					case SDLK_UP:
						sel--;
						changed = 1;
						break;
					case SDLK_DOWN:
						sel++;
						changed = 1;
						break;
					case SDLK_RIGHT:
						if(sel == 1 && options.mc.r != 255)	{
							options.mc.r++;
							options.bc.mr = (options.bc.r + options.mc.r) / 2;
						}
						else if(sel == 2 && options.mc.g != 255)	{
							options.mc.g++;
							options.bc.mg = (options.bc.g + options.mc.g) / 2;
						}
						else if(sel == 3 && options.mc.b != 255)	{
							options.mc.b++;
							options.bc.mb = (options.bc.mb + options.mc.b) / 2;
						}
						else if(sel == 4 && options.bc.r != 255)	{
							options.bc.r++;
							options.bc.mr = (options.bc.r + options.mc.r) / 2;
						}
						else if(sel == 5 && options.bc.g != 255)	{
							options.bc.g++;
							options.bc.mg = (options.bc.g + options.mc.g) / 2;
						}
						else if(sel == 6 && options.bc.b != 255)	{
							options.bc.b++;
							options.bc.mb = (options.bc.b + options.mc.b) / 2;
						}
						else if(sel == 7 && options.tc.r != 255)
							options.tc.r++;
						else if(sel == 8 && options.tc.g != 255)
							options.tc.g++;
						else if(sel == 9 && options.tc.b != 255)
							options.tc.b++;

						changed = 1;
						break;
					case SDLK_LEFT:
						if(sel == 1 && options.mc.r != 0)	{
							options.mc.r--;
							options.bc.mr = (options.bc.r + options.mc.r) / 2;
						}
						else if(sel == 2 && options.mc.g != 0)	{
							options.mc.g--;
							options.bc.mg = (options.bc.g + options.mc.g) / 2;
						}
						else if(sel == 3 && options.mc.b != 0)	{
							options.mc.b--;
							options.bc.mb = (options.bc.mb + options.mc.b) / 2;
						}
						else if(sel == 4 && options.bc.r != 0)	{
							options.bc.r--;
							options.bc.mr = (options.bc.r + options.mc.r) / 2;
						}
						else if(sel == 5 && options.bc.g != 0)	{
							options.bc.g--;
							options.bc.mg = (options.bc.g + options.mc.g) / 2;
						}
						else if(sel == 6 && options.bc.b != 0)	{
							options.bc.b--;
							options.bc.mb = (options.bc.b + options.mc.b) / 2;
						}
						else if(sel == 7 && options.tc.r != 0)
							options.tc.r--;
						else if(sel == 8 && options.tc.g != 0)
							options.tc.g--;
						else if(sel == 9 && options.tc.b != 0)
							options.tc.b--;

						changed = 1;
						break;

					case SDLK_ESCAPE:
						menudone = 1;
						break;
				}
				break;
			case SDL_JOYHATMOTION:
				if(event.jhat.value == SDL_HAT_UP)	{
					sel--;
					changed = 1;
				}
				if(event.jhat.value == SDL_HAT_DOWN)	{
					sel++;
					changed = 1;
				}
				if(event.jhat.value == SDL_HAT_RIGHT)	{
					if(sel == 1 && options.mc.r != 255)	{
						options.mc.r++;
						options.bc.mr = (options.bc.r + options.mc.r) / 2;
					}
					else if(sel == 2 && options.mc.g != 255)	{
						options.mc.g++;
						options.bc.mg = (options.bc.g + options.mc.g) / 2;
					}
					else if(sel == 3 && options.mc.b != 255)	{
						options.mc.b++;
						options.bc.mb = (options.bc.mb + options.mc.b) / 2;
					}
					else if(sel == 4 && options.bc.r != 255)	{
						options.bc.r++;
						options.bc.mr = (options.bc.r + options.mc.r) / 2;
					}
					else if(sel == 5 && options.bc.g != 255)	{
						options.bc.g++;
						options.bc.mg = (options.bc.g + options.mc.g) / 2;
					}
					else if(sel == 6 && options.bc.b != 255)	{
						options.bc.b++;
						options.bc.mb = (options.bc.b + options.mc.b) / 2;
					}
					else if(sel == 7 && options.tc.r != 255)
						options.tc.r++;
					else if(sel == 8 && options.tc.g != 255)
						options.tc.g++;
					else if(sel == 9 && options.tc.b != 255)
						options.tc.b++;

					changed = 1;
				}
				if(event.jhat.value == SDL_HAT_LEFT)	{
					if(sel == 1 && options.mc.r != 0)	{
						options.mc.r--;
						options.bc.mr = (options.bc.r + options.mc.r) / 2;
					}
					else if(sel == 2 && options.mc.g != 0)	{
						options.mc.g--;
						options.bc.mg = (options.bc.g + options.mc.g) / 2;
					}
					else if(sel == 3 && options.mc.b != 0)	{
						options.mc.b--;
						options.bc.mb = (options.bc.mb + options.mc.b) / 2;
					}
					else if(sel == 4 && options.bc.r != 0)	{
						options.bc.r--;
						options.bc.mr = (options.bc.r + options.mc.r) / 2;
					}
					else if(sel == 5 && options.bc.g != 0)	{
						options.bc.g--;
						options.bc.mg = (options.bc.g + options.mc.g) / 2;
					}
					else if(sel == 6 && options.bc.b != 0)	{
						options.bc.b--;
						options.bc.mb = (options.bc.b + options.mc.b) / 2;
					}
					else if(sel == 7 && options.tc.r != 0)
						options.tc.r--;
					else if(sel == 8 && options.tc.g != 0)
						options.tc.g--;
					else if(sel == 9 && options.tc.b != 0)
						options.tc.b--;

					changed = 1;
				}
				break;
			case SDL_JOYAXISMOTION:
				if(event.jaxis.axis == 1 && event.jaxis.value < -joyval)	{
					sel--;
					changed = 1;
				}
				if(event.jaxis.axis == 1 && event.jaxis.value > joyval)	{
					sel++;
					changed = 1;
				}
				if(event.jaxis.axis == 0 && event.jaxis.value > joyval)	{
					if(sel == 1 && options.mc.r != 255)	{
						options.mc.r++;
						options.bc.mr = (options.bc.r + options.mc.r) / 2;
					}
					else if(sel == 2 && options.mc.g != 255)	{
						options.mc.g++;
						options.bc.mg = (options.bc.g + options.mc.g) / 2;
					}
					else if(sel == 3 && options.mc.b != 255)	{
						options.mc.b++;
						options.bc.mb = (options.bc.mb + options.mc.b) / 2;
					}
					else if(sel == 4 && options.bc.r != 255)	{
						options.bc.r++;
						options.bc.mr = (options.bc.r + options.mc.r) / 2;
					}
					else if(sel == 5 && options.bc.g != 255)	{
						options.bc.g++;
						options.bc.mg = (options.bc.g + options.mc.g) / 2;
					}
					else if(sel == 6 && options.bc.b != 255)	{
						options.bc.b++;
						options.bc.mb = (options.bc.b + options.mc.b) / 2;
					}
					else if(sel == 7 && options.tc.r != 255)
						options.tc.r++;
					else if(sel == 8 && options.tc.g != 255)
						options.tc.g++;
					else if(sel == 9 && options.tc.b != 255)
						options.tc.b++;

					changed = 1;
				}
				if(event.jaxis.axis == 0 && event.jaxis.value < -joyval)	{
					if(sel == 1 && options.mc.r != 0)	{
						options.mc.r--;
						options.bc.mr = (options.bc.r + options.mc.r) / 2;
					}
					else if(sel == 2 && options.mc.g != 0)	{
						options.mc.g--;
						options.bc.mg = (options.bc.g + options.mc.g) / 2;
					}
					else if(sel == 3 && options.mc.b != 0)	{
						options.mc.b--;
						options.bc.mb = (options.bc.mb + options.mc.b) / 2;
					}
					else if(sel == 4 && options.bc.r != 0)	{
						options.bc.r--;
						options.bc.mr = (options.bc.r + options.mc.r) / 2;
					}
					else if(sel == 5 && options.bc.g != 0)	{
						options.bc.g--;
						options.bc.mg = (options.bc.g + options.mc.g) / 2;
					}
					else if(sel == 6 && options.bc.b != 0)	{
						options.bc.b--;
						options.bc.mb = (options.bc.b + options.mc.b) / 2;
					}
					else if(sel == 7 && options.tc.r != 0)
						options.tc.r--;
					else if(sel == 8 && options.tc.g != 0)
						options.tc.g--;
					else if(sel == 9 && options.tc.b != 0)
						options.tc.b--;

					changed = 1;
				}
				break;
			case SDL_JOYBUTTONDOWN:
				if(event.jbutton.button == 0)	{
					if(sel == 0)
						save_game(screen);
					if(sel == 10)
						load_game(screen);
				}
				if(event.jbutton.button == 4)	{
					menudone = 1;
				}
				if(event.jbutton.button == 1)	{
					menudone = 1;
				}
				break;
		}
		if(frommenu == 1)	{
			if(sel < 0)
				sel = 10;
			if(sel > 10)
				sel = 0;
		}
		else	{
			if(sel < 1)
				sel = 9;
			if(sel > 9)
				sel = 1;
		}

		if(changed == 1)	{
			rect = rect_set(640, 480, 0, 0);
			SDL_FillRect(buffer, &rect, SDL_MapRGB(buffer->format, options.mc.r, options.mc.g, options.mc.b));
			menu_opt_st_draw(buffer);
			menu_opt_arrow(buffer, sel);
			menu_opt_txt(buffer, frommenu);
			SDL_BlitSurface(buffer, NULL, screen, NULL);
			SDL_Flip(screen);
			SDL_Delay(100);
			changed = 0;
		}
	}
}

static void menu_st_txt(SDL_Surface * buffer, int pm)	{
	char cl[16];
	if(stats[pm].stats.rank == 0)	{
		strcpy(cl, "Fighter");
	}
	else if(stats[pm].stats.rank == 1)	{
		strcpy(cl, "Thief");
	}
	else if(stats[pm].stats.rank == 2)	{
		strcpy(cl, "Black Mage");
	}
	else if(stats[pm].stats.rank == 3)	{
		strcpy(cl, "White Mage");
	}
	sge_TTF_SetFontSize(font, 16);
	sge_TTF_SetFontStyle(font, SGE_TTF_NORMAL);
	sge_tt_textout(buffer, font, "Stats", 48, 64, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE);
	sge_tt_textoutf(buffer, font, 176, 64, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Name: %s", stats[pm].name);
	sge_tt_textoutf(buffer, font, 176, 80, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Rank: %s", cl);
	sge_tt_textoutf(buffer, font, 176, 96, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Level: %d", stats[pm].stats.level);
	sge_tt_textoutf(buffer, font, 176, 112, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Total Experience: %d", stats[pm].stats.exp);
	sge_tt_textoutf(buffer, font, 176, 128, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "To Next Level: %d", (exp_to_level * (int) pow(stats[pm].stats.level, 2)) - stats[pm].stats.exp);
	sge_tt_textoutf(buffer, font, 176, 160, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "HP Remaining: %d", stats[pm].stats.hp_rem);
	sge_tt_textoutf(buffer, font, 176, 176, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Total HP: %d", stats[pm].stats.hp);
	sge_tt_textoutf(buffer, font, 176, 192, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "MP Remaining: %d", stats[pm].stats.mp_rem);
	sge_tt_textoutf(buffer, font, 176, 208, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Total MP: %d", stats[pm].stats.mp);
	sge_tt_textoutf(buffer, font, 176, 240, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Attack: %d", stats[pm].stats.attack);
	sge_tt_textoutf(buffer, font, 176, 256, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Strength: %d", stats[pm].stats.strength);
	sge_tt_textoutf(buffer, font, 176, 272, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Defense: %d", stats[pm].stats.defense);
	sge_tt_textoutf(buffer, font, 176, 288, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Speed: %d", stats[pm].stats.speed);
	sge_tt_textoutf(buffer, font, 176, 304, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Magic Defense: %d", stats[pm].stats.mdef);
	sge_tt_textoutf(buffer, font, 176, 320, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Magic Attack: %d", stats[pm].stats.matt);
	sge_tt_textoutf(buffer, font, 176, 336, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Intelligence: %d", stats[pm].stats.intel);
	sge_tt_textoutf(buffer, font, 176, 352, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Accuracy: %d", stats[pm].stats.accuracy);
	sge_tt_textoutf(buffer, font, 176, 400, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Kills: %d", stats[pm].bat.kills);
	sge_tt_textoutf(buffer, font, 176, 416, options.tc.r, options.tc.g, options.tc.b, options.mc.r, options.mc.g, options.mc.b, SDL_ALPHA_OPAQUE, "Defeats: %d", stats[pm].bat.defeats);
}

static void menu_st_img(SDL_Surface * buffer)	{
}

void menu_stat_menu(SDL_Surface * buffer, SDL_Surface * screen, int partymem)	{
	SDL_Rect rect;
	SDL_Event event;
	int menudone = 0;

	rect = rect_set(640, 480, 0, 0);
	SDL_FillRect(buffer, &rect, SDL_MapRGB(buffer->format, options.mc.r, options.mc.g, options.mc.b));
	menu_opt_st_draw(buffer);
	menu_st_img(buffer);
	menu_st_txt(buffer, partymem);
	SDL_BlitSurface(buffer, NULL, screen, NULL);
	SDL_Flip(screen);

	while(menudone == 0)	{
		SDL_PollEvent(NULL);
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_RETURN:
						menudone = 1;
						break;
					case SDLK_ESCAPE:
						menudone = 1;
						break;
				}
				break;
			case SDL_JOYBUTTONDOWN:
				if(event.jbutton.button == 4)	{
					menudone = 1;
				}
				if(event.jbutton.button == 1)	{
					menudone = 1;
				}
				break;
		}
	}
}
