/*	enemies.cpp -- ljsdcdev
	Enemy creator program
	ljsdcdev
	(c) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>

typedef struct	{
	char name[9];
	unsigned int attack;
	unsigned int defense;
	unsigned int speed;
	unsigned int strength;
	unsigned int mdef;
	unsigned int matt;
	unsigned int intel;
	unsigned int accuracy;
	unsigned int hp;
	unsigned int mp;
	unsigned int exp;
	unsigned int magics[4][3];
} en_dat_t;

int main(int argc, char * argv[])	{
	en_dat_t enemy;
	FILE * fp;
	char input[20];
	char in[20];
	char * img_data;
	struct stat stats;
	int img_size;
	char fn[13];
	char * data;

	printf("Input Enemy Name: ");
	gets(input);
	strcpy(enemy.name, input);
	printf("Input Enemy Attack: ");
	gets(input);
	enemy.attack = atoi(input);
	printf("Input Enemy Defense: ");
	gets(input);
	enemy.defense = atoi(input);
	printf("Input Enemy Speed: ");
	gets(input);
	enemy.speed = atoi(input);
	printf("Input Enemy Magic Defense: ");
	gets(input);
	enemy.mdef = atoi(input);
	printf("Input Enemy Magic Attack: ");
	gets(input);
	enemy.matt = atoi(input);
	printf("Input Enemy Intelligence: ");
	gets(input);
	enemy.intel = atoi(input);
	printf("Input Enemy Accuracy: ");
	gets(input);
	enemy.accuracy = atoi(input);
	printf("Input Enemy HP: ");
	gets(input);
	enemy.hp = atoi(input);
	printf("Input Enemy MP: ");
	gets(input);
	enemy.mp = atoi(input);
	printf("Input Experience Gained by defeating: ");
	gets(input);
	enemy.exp = atoi(input);
	printf("Input Enemy Image Filename: ");
	gets(in);
	printf("\n\n\n\n");
	printf("Enemy Overview:\n");

	printf("Enemy Name: %s\n", enemy.name);
	printf("Stats:\n");
	printf("Attack: %d\n", enemy.attack);
	printf("Defense: %d\n", enemy.defense);
	printf("Speed: %d\n", enemy.speed);
	printf("Magic Defense: %d\n", enemy.mdef);
	printf("Magic Attack: %d\n", enemy.matt);
	printf("Intelligence: %d\n", enemy.intel);
	printf("Accuracy: %d\n", enemy.accuracy);
	printf("HP: %d\n", enemy.hp);
	printf("MP: %d\n", enemy.mp);
	printf("Experience Gained: %d\n", enemy.exp);
	printf("Enemy image filename: %s\n\n", in);

	stat(in, &stats);
	img_size = stats.st_size;
	img_data = (char *) malloc(img_size);
	FILE * img = fopen(in, "rb");
	fread(img_data, img_size, 1, img);
	fclose(img);

	sprintf(fn, "%s.lje", enemy.name);

	fp = fopen(fn, "wb");

	data = (char *) malloc(sizeof(en_dat_t));
	memcpy(data, &enemy, sizeof(en_dat_t));

	fwrite(data, sizeof(en_dat_t), 1, fp);

	char *ext = strrchr(fn, '.');

	fwrite(ext, sizeof(char)*3, 1, fp);

	fwrite(&img_size, sizeof(int), 1, fp);

	fwrite(img_data, img_size, 1, fp);

	fclose(fp);
	free(data);
	free(img_data);
	printf("Enemy %s created!\n", enemy.name);
	printf("Enemy filename: %s\n", fn);
	return 0;
}
