/*	enemyview.cpp -- ljsdcdev
	Enemy viewer program
	ljsdcdev
	(c) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "SDL.h"
#include "sge.h"
#include "SDL_image.h"

typedef struct	{
	char name[9];
	unsigned int attack;
	unsigned int defense;
	unsigned int speed;
	unsigned int strength;
	unsigned int mdef;
	unsigned int matt;
	unsigned int intel;
	unsigned int accuracy;
	unsigned int hp;
	unsigned int mp;
	unsigned int exp;
	unsigned int magics[4][3];
} en_dat_t;

en_dat_t enemy;
sge_TTFont * font;
SDL_Surface * image;

static void enview_bd_draw(SDL_Surface * buffer)	{
	sge_Line(buffer, 32, 48, 48, 32, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 32, 47, 48, 31, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 32, 49, 48, 33, 0x7E, 0x7E, 0x7E);

	sge_Line(buffer, 160, 48, 176, 32, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 160, 47, 176, 31, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 160, 49, 176, 33, 0x7E, 0x7E, 0x7E);

	sge_Line(buffer, 128, 32, 144, 48, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 128, 31, 144, 47, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 128, 33, 144, 49, 0x7E, 0x7E, 0x7E);

	sge_Line(buffer, 592, 32, 608, 48, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 592, 31, 608, 47, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 592, 33, 608, 49, 0x7E, 0x7E, 0x7E);

	sge_Line(buffer, 32, 64, 48, 80, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 32, 63, 48, 79, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 32, 65, 48, 81, 0x7E, 0x7E, 0x7E);

	sge_Line(buffer, 160, 432, 176, 448, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 160, 431, 176, 447, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 160, 433, 176, 449, 0x7E, 0x7E, 0x7E);

	sge_Line(buffer, 128, 80, 144, 64, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 128, 79, 144, 63, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 128, 81, 144, 65, 0x7E, 0x7E, 0x7E);

	sge_Line(buffer, 592, 448, 608, 432, 0xFF, 0xFF, 0xFF);
	sge_Line(buffer, 592, 447, 608, 431, 0x7E, 0x7E, 0x7E);
	sge_Line(buffer, 592, 449, 608, 433, 0x7E, 0x7E, 0x7E);

	sge_HLine(buffer, 48, 128, 32, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 48, 128, 31, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 48, 128, 33, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 48, 128, 80, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 48, 128, 79, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 48, 128, 81, 0x7E, 0x7E, 0x7E);

	sge_HLine(buffer, 176, 592, 32, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 176, 592, 31, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 176, 592, 33, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 176, 592, 448, 0xFF, 0xFF, 0xFF);
	sge_HLine(buffer, 176, 592, 447, 0x7E, 0x7E, 0x7E);
	sge_HLine(buffer, 176, 592, 449, 0x7E, 0x7E, 0x7E);

	sge_VLine(buffer, 32, 48, 64, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 31, 48, 64, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 33, 48, 64, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 144, 48, 64, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 143, 48, 64, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 145, 48, 64, 0x7E, 0x7E, 0x7E);

	sge_VLine(buffer, 160, 48, 432, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 159, 48, 432, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 161, 48, 432, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 608, 48, 432, 0xFF, 0xFF, 0xFF);
	sge_VLine(buffer, 607, 48, 432, 0x7E, 0x7E, 0x7E);
	sge_VLine(buffer, 609, 48, 432, 0x7E, 0x7E, 0x7E);
}

static void enview_txt_draw(SDL_Surface * buffer)	{
	sge_TTF_SetFontSize(font, 16);
	sge_TTF_SetFontStyle(font, SGE_TTF_NORMAL);
	sge_tt_textout(buffer, font, "Enemy", 48, 64, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE);
	sge_tt_textoutf(buffer, font, 176, 64, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Name: %s", enemy.name);
	sge_tt_textoutf(buffer, font, 176, 128, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Experience Gained By Defeat: %d", enemy.exp);
	sge_tt_textoutf(buffer, font, 176, 176, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Total HP: %d", enemy.hp);
	sge_tt_textoutf(buffer, font, 176, 208, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Total MP: %d", enemy.mp);
	sge_tt_textoutf(buffer, font, 176, 240, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Attack: %d", enemy.attack);
	sge_tt_textoutf(buffer, font, 176, 272, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Defense: %d", enemy.defense);
	sge_tt_textoutf(buffer, font, 176, 288, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Speed: %d", enemy.speed);
	sge_tt_textoutf(buffer, font, 176, 304, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Magic Defense: %d", enemy.mdef);
	sge_tt_textoutf(buffer, font, 176, 320, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Magic Attack: %d", enemy.matt);
	sge_tt_textoutf(buffer, font, 176, 336, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Intelligence: %d", enemy.intel);
	sge_tt_textoutf(buffer, font, 176, 352, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xFF, SDL_ALPHA_OPAQUE, "Accuracy: %d", enemy.accuracy);
}

static void enview_img(SDL_Surface * screen)	{
	SDL_Rect rect;
	rect.x = 48;
	rect.y = 128;
	rect.w = 32;
	rect.h = 32;
	SDL_BlitSurface(image, NULL, screen, &rect);
}

void enview_stats(SDL_Surface * screen)	{
	SDL_Rect rect;
	SDL_Event event;
	int menudone = 0;

	rect.x = 0;
	rect.y = 0;
	rect.w = 640;
	rect.h = 480;
	SDL_FillRect(screen, &rect, SDL_MapRGB(screen->format, 0x00, 0x00, 0xFF));
	enview_bd_draw(screen);
	enview_img(screen);
	enview_txt_draw(screen);
	SDL_Flip(screen);

	while(menudone == 0)	{
		SDL_PollEvent(NULL);
		SDL_PollEvent(&event);
		switch(event.type)	{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)	{
					case SDLK_RETURN:
						menudone = 1;
						break;
					case SDLK_ESCAPE:
						menudone = 1;
						break;
				}
				break;
		}
	}
}

int main(int argc, char * argv[])	{
	FILE * fp;

	if(argc != 2)	{
		printf("ljsdcdev Enemy Viewer 0.1\n"
		"Usage:\n"
		"%s [fn]\n"
		"[fn] - Enemy file to view\n", argv[0]);
		exit(0);
	}
	if(SDL_Init(SDL_INIT_VIDEO) < 0)	{
		return -1;
	}
	atexit(SDL_Quit);

	if(sge_TTF_Init() != 0)	{
		return -1;
	}

	font = sge_TTF_OpenFont("font.ttf", 16);

	SDL_Surface * screen;
	SDL_RWops * mem;

	SDL_WM_SetCaption("ljsdcdev Enemy Viewer 0.1", NULL);

	screen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE);

	fp = fopen(argv[1], "rb");

	char * data = (char *) malloc(sizeof(en_dat_t));
	fread(data, sizeof(en_dat_t), 1, fp);
	memcpy(&enemy, data, sizeof(en_dat_t));
	free(data);

	char ext[3];
	fread(ext, sizeof(char)*3, 1, fp);

	int img_size;
	char * dat = (char *) malloc(sizeof(int));
	fread(dat, sizeof(int), 1, fp);
	memcpy(&img_size, dat, sizeof(int));
	free(dat);

	char * img = (char *) malloc(img_size);
	fread(img, img_size, 1, fp);

	mem = SDL_RWFromMem(img, img_size);

	image = IMG_LoadTyped_RW(mem, 1, ext);

	enview_stats(screen);
	return 0;
}

